/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 2 "../../../../src/oc/parse.ypp"


#include <../../nrnconf.h>
/* changes as of 2-jan-89 */
/*  version 7.2.1 2-jan-89 short form of the for statement */

#if AIX
#pragma alloca
#endif

#include "hoc.h"
#include "ocmisc.h"
#include "hocparse.h"
#include "code.h"
#include "equation.h"
#include "nrnfilewrap.h"

void* nrn_parsing_pysec_;

#if LINT
Inst *inlint;
#define code	inlint = Code
#else
#define code	Code
#endif

#define paction(arg) fprintf(stderr, "%s\n", arg)

/* maintain a list of ierr addresses so we can clear them */
#define HOCERRSIZE 20
static int** hoc_err;
static int hoc_errp;
static int localcnt;

static void clean_err(void) {
	int i;
	for (i=0; i < hoc_errp; ++i) {
		*hoc_err[i] = 0;
	}
	hoc_errp = 0;
}

static void pusherr(int* ip) {
	if (!hoc_err) {
		hoc_err = (int**)ecalloc(HOCERRSIZE, sizeof(int*));
		hoc_errp = 0;
	}
	if (hoc_errp >= HOCERRSIZE) {
		clean_err();
		hoc_execerror("error stack full", (char*)0);
	}
	hoc_err[hoc_errp++] = ip;
}

static void yyerror(const char* s);

#if YYBISON
#define myerr(arg) static int ierr=0;\
if (!(ierr++)){pusherr(&ierr);yyerror(arg);} --yyssp; --yyvsp; YYERROR
#else
#define myerr(arg) static int ierr=0;\
if (!(ierr++)){pusherr(&ierr);yyerror(arg);} YYERROR
#endif

#define code2(c1,c2)	code(c1); codein(c2)
#define code3(c1,c2,c3)	code(c1); codesym(c2); code(c3)
#define relative(ip1,ip2,offset)	((ip1-ip2) - offset)
#define CHECK 1	/* check syntactically the consistency of arrays */
#define NOCHECK 0 /* don't check syntactically. For object components */
#define PN pushi(NUMBER)	/* for type checking. expressions are usually numbers */
#define TPD hoc_ob_check(NUMBER);
#define TPDYNAM hoc_ob_check(0);

static Inst *prog_error;			/* needed for stmtlist loc if error */
static int ntab;			/* auto indentation */

static Inst* argrefcode(Pfrv pfrv, int i, int j);
static Inst* argcode(Pfrv pfrv, int i);
static void hoc_opasgn_invalid(int op);
 

#line 153 "parse.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parse.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_EQNEQ = 3,                      /* EQNEQ  */
  YYSYMBOL_NUMBER = 4,                     /* NUMBER  */
  YYSYMBOL_STRING = 5,                     /* STRING  */
  YYSYMBOL_PRINT = 6,                      /* PRINT  */
  YYSYMBOL_parseDELETE = 7,                /* parseDELETE  */
  YYSYMBOL_VAR = 8,                        /* VAR  */
  YYSYMBOL_BLTIN = 9,                      /* BLTIN  */
  YYSYMBOL_UNDEF = 10,                     /* UNDEF  */
  YYSYMBOL_WHILE = 11,                     /* WHILE  */
  YYSYMBOL_IF = 12,                        /* IF  */
  YYSYMBOL_ELSE = 13,                      /* ELSE  */
  YYSYMBOL_FOR = 14,                       /* FOR  */
  YYSYMBOL_FUNCTION = 15,                  /* FUNCTION  */
  YYSYMBOL_PROCEDURE = 16,                 /* PROCEDURE  */
  YYSYMBOL_RETURN = 17,                    /* RETURN  */
  YYSYMBOL_FUNC = 18,                      /* FUNC  */
  YYSYMBOL_parsePROC = 19,                 /* parsePROC  */
  YYSYMBOL_HOCOBJFUNC = 20,                /* HOCOBJFUNC  */
  YYSYMBOL_READ = 21,                      /* READ  */
  YYSYMBOL_parseDOUBLE = 22,               /* parseDOUBLE  */
  YYSYMBOL_DEBUG = 23,                     /* DEBUG  */
  YYSYMBOL_EDIT = 24,                      /* EDIT  */
  YYSYMBOL_FUN_BLTIN = 25,                 /* FUN_BLTIN  */
  YYSYMBOL_DEPENDENT = 26,                 /* DEPENDENT  */
  YYSYMBOL_EQUATION = 27,                  /* EQUATION  */
  YYSYMBOL_LOCAL = 28,                     /* LOCAL  */
  YYSYMBOL_HOCOBJFUNCTION = 29,            /* HOCOBJFUNCTION  */
  YYSYMBOL_BREAK = 30,                     /* BREAK  */
  YYSYMBOL_CONTINUE = 31,                  /* CONTINUE  */
  YYSYMBOL_AUTO = 32,                      /* AUTO  */
  YYSYMBOL_STRDEF = 33,                    /* STRDEF  */
  YYSYMBOL_STOPSTMT = 34,                  /* STOPSTMT  */
  YYSYMBOL_CSTRING = 35,                   /* CSTRING  */
  YYSYMBOL_PARALLEL = 36,                  /* PARALLEL  */
  YYSYMBOL_HELP = 37,                      /* HELP  */
  YYSYMBOL_ITERATOR = 38,                  /* ITERATOR  */
  YYSYMBOL_ITERKEYWORD = 39,               /* ITERKEYWORD  */
  YYSYMBOL_ITERSTMT = 40,                  /* ITERSTMT  */
  YYSYMBOL_STRINGFUNC = 41,                /* STRINGFUNC  */
  YYSYMBOL_OBJECTFUNC = 42,                /* OBJECTFUNC  */
  YYSYMBOL_LOCALOBJ = 43,                  /* LOCALOBJ  */
  YYSYMBOL_AUTOOBJ = 44,                   /* AUTOOBJ  */
  YYSYMBOL_ARG = 45,                       /* ARG  */
  YYSYMBOL_NUMZERO = 46,                   /* NUMZERO  */
  YYSYMBOL_ARGREF = 47,                    /* ARGREF  */
  YYSYMBOL_INTERNALSECTIONNAME = 48,       /* INTERNALSECTIONNAME  */
  YYSYMBOL_PYSEC = 49,                     /* PYSEC  */
  YYSYMBOL_PYSECNAME = 50,                 /* PYSECNAME  */
  YYSYMBOL_PYSECOBJ = 51,                  /* PYSECOBJ  */
  YYSYMBOL_SECTIONKEYWORD = 52,            /* SECTIONKEYWORD  */
  YYSYMBOL_SECTION = 53,                   /* SECTION  */
  YYSYMBOL_CONNECTKEYWORD = 54,            /* CONNECTKEYWORD  */
  YYSYMBOL_ACCESSKEYWORD = 55,             /* ACCESSKEYWORD  */
  YYSYMBOL_RANGEVAR = 56,                  /* RANGEVAR  */
  YYSYMBOL_MECHANISM = 57,                 /* MECHANISM  */
  YYSYMBOL_INSERTKEYWORD = 58,             /* INSERTKEYWORD  */
  YYSYMBOL_FORALL = 59,                    /* FORALL  */
  YYSYMBOL_NRNPNTVAR = 60,                 /* NRNPNTVAR  */
  YYSYMBOL_FORSEC = 61,                    /* FORSEC  */
  YYSYMBOL_IFSEC = 62,                     /* IFSEC  */
  YYSYMBOL_UNINSERTKEYWORD = 63,           /* UNINSERTKEYWORD  */
  YYSYMBOL_SETPOINTERKEYWORD = 64,         /* SETPOINTERKEYWORD  */
  YYSYMBOL_SECTIONREF = 65,                /* SECTIONREF  */
  YYSYMBOL_BEGINTEMPLATE = 66,             /* BEGINTEMPLATE  */
  YYSYMBOL_ENDTEMPLATE = 67,               /* ENDTEMPLATE  */
  YYSYMBOL_NEW = 68,                       /* NEW  */
  YYSYMBOL_OBJECTVAR = 69,                 /* OBJECTVAR  */
  YYSYMBOL_TEMPLATE = 70,                  /* TEMPLATE  */
  YYSYMBOL_OBJVARDECL = 71,                /* OBJVARDECL  */
  YYSYMBOL_PUBLICDECL = 72,                /* PUBLICDECL  */
  YYSYMBOL_EXTERNALDECL = 73,              /* EXTERNALDECL  */
  YYSYMBOL_OBFUNCTION = 74,                /* OBFUNCTION  */
  YYSYMBOL_STRFUNCTION = 75,               /* STRFUNCTION  */
  YYSYMBOL_OBJECTARG = 76,                 /* OBJECTARG  */
  YYSYMBOL_STRINGARG = 77,                 /* STRINGARG  */
  YYSYMBOL_ROP = 78,                       /* ROP  */
  YYSYMBOL_79_ = 79,                       /* '='  */
  YYSYMBOL_OR = 80,                        /* OR  */
  YYSYMBOL_AND = 81,                       /* AND  */
  YYSYMBOL_GT = 82,                        /* GT  */
  YYSYMBOL_GE = 83,                        /* GE  */
  YYSYMBOL_LT = 84,                        /* LT  */
  YYSYMBOL_LE = 85,                        /* LE  */
  YYSYMBOL_EQ = 86,                        /* EQ  */
  YYSYMBOL_NE = 87,                        /* NE  */
  YYSYMBOL_88_ = 88,                       /* '+'  */
  YYSYMBOL_89_ = 89,                       /* '-'  */
  YYSYMBOL_90_ = 90,                       /* '*'  */
  YYSYMBOL_91_ = 91,                       /* '/'  */
  YYSYMBOL_92_ = 92,                       /* '%'  */
  YYSYMBOL_UNARYMINUS = 93,                /* UNARYMINUS  */
  YYSYMBOL_NOT = 94,                       /* NOT  */
  YYSYMBOL_95_ = 95,                       /* '^'  */
  YYSYMBOL_96_n_ = 96,                     /* '\n'  */
  YYSYMBOL_97_ = 97,                       /* '('  */
  YYSYMBOL_98_ = 98,                       /* ')'  */
  YYSYMBOL_99_ = 99,                       /* '['  */
  YYSYMBOL_100_ = 100,                     /* ']'  */
  YYSYMBOL_101_ = 101,                     /* '.'  */
  YYSYMBOL_102_ = 102,                     /* ','  */
  YYSYMBOL_103_ = 103,                     /* '{'  */
  YYSYMBOL_104_ = 104,                     /* '}'  */
  YYSYMBOL_105_ = 105,                     /* ':'  */
  YYSYMBOL_106_ = 106,                     /* ';'  */
  YYSYMBOL_107_ = 107,                     /* '&'  */
  YYSYMBOL_YYACCEPT = 108,                 /* $accept  */
  YYSYMBOL_list = 109,                     /* list  */
  YYSYMBOL_110_1 = 110,                    /* $@1  */
  YYSYMBOL_asgn = 111,                     /* asgn  */
  YYSYMBOL_object = 112,                   /* object  */
  YYSYMBOL_113_2 = 113,                    /* $@2  */
  YYSYMBOL_ob = 114,                       /* ob  */
  YYSYMBOL_ob1 = 115,                      /* ob1  */
  YYSYMBOL_116_3 = 116,                    /* $@3  */
  YYSYMBOL_func_or_range_array_case = 117, /* func_or_range_array_case  */
  YYSYMBOL_template = 118,                 /* template  */
  YYSYMBOL_objvarlist = 119,               /* objvarlist  */
  YYSYMBOL_objvarlst1 = 120,               /* objvarlst1  */
  YYSYMBOL_obvarname = 121,                /* obvarname  */
  YYSYMBOL_publiclist = 122,               /* publiclist  */
  YYSYMBOL_externallist = 123,             /* externallist  */
  YYSYMBOL_strnasgn = 124,                 /* strnasgn  */
  YYSYMBOL_string1 = 125,                  /* string1  */
  YYSYMBOL_string2 = 126,                  /* string2  */
  YYSYMBOL_strlist = 127,                  /* strlist  */
  YYSYMBOL_string = 128,                   /* string  */
  YYSYMBOL_stmt = 129,                     /* stmt  */
  YYSYMBOL_130_4 = 130,                    /* @4  */
  YYSYMBOL_131_5 = 131,                    /* @5  */
  YYSYMBOL_132_6 = 132,                    /* @6  */
  YYSYMBOL_133_7 = 133,                    /* @7  */
  YYSYMBOL_134_8 = 134,                    /* $@8  */
  YYSYMBOL_135_9 = 135,                    /* $@9  */
  YYSYMBOL_136_10 = 136,                   /* @10  */
  YYSYMBOL_137_11 = 137,                   /* $@11  */
  YYSYMBOL_138_12 = 138,                   /* @12  */
  YYSYMBOL_139_13 = 139,                   /* @13  */
  YYSYMBOL_140_14 = 140,                   /* @14  */
  YYSYMBOL_141_15 = 141,                   /* @15  */
  YYSYMBOL_142_16 = 142,                   /* @16  */
  YYSYMBOL_143_17 = 143,                   /* @17  */
  YYSYMBOL_iterator = 144,                 /* iterator  */
  YYSYMBOL_145_18 = 145,                   /* $@18  */
  YYSYMBOL_section = 146,                  /* section  */
  YYSYMBOL_147_19 = 147,                   /* $@19  */
  YYSYMBOL_pysec = 148,                    /* pysec  */
  YYSYMBOL_pysec1 = 149,                   /* pysec1  */
  YYSYMBOL_section_or_ob = 150,            /* section_or_ob  */
  YYSYMBOL_151_20 = 151,                   /* @20  */
  YYSYMBOL_sectiondecl = 152,              /* sectiondecl  */
  YYSYMBOL_sectionname = 153,              /* sectionname  */
  YYSYMBOL_rangevar = 154,                 /* rangevar  */
  YYSYMBOL_rangevar1 = 155,                /* rangevar1  */
  YYSYMBOL_156_21 = 156,                   /* $@21  */
  YYSYMBOL_pointer = 157,                  /* pointer  */
  YYSYMBOL_for_init = 158,                 /* for_init  */
  YYSYMBOL_for_st = 159,                   /* for_st  */
  YYSYMBOL_for_cond = 160,                 /* for_cond  */
  YYSYMBOL_for_inc = 161,                  /* for_inc  */
  YYSYMBOL_cond = 162,                     /* cond  */
  YYSYMBOL_while = 163,                    /* while  */
  YYSYMBOL_if = 164,                       /* if  */
  YYSYMBOL_begin = 165,                    /* begin  */
  YYSYMBOL_end = 166,                      /* end  */
  YYSYMBOL_stmtlist = 167,                 /* stmtlist  */
  YYSYMBOL_expr = 168,                     /* expr  */
  YYSYMBOL_function = 169,                 /* function  */
  YYSYMBOL_doublelist = 170,               /* doublelist  */
  YYSYMBOL_newarray = 171,                 /* newarray  */
  YYSYMBOL_numdimen = 172,                 /* numdimen  */
  YYSYMBOL_newname = 173,                  /* newname  */
  YYSYMBOL_varname = 174,                  /* varname  */
  YYSYMBOL_175_22 = 175,                   /* $@22  */
  YYSYMBOL_wholearray = 176,               /* wholearray  */
  YYSYMBOL_argrefdim = 177,                /* argrefdim  */
  YYSYMBOL_array = 178,                    /* array  */
  YYSYMBOL_prlist = 179,                   /* prlist  */
  YYSYMBOL_delsym = 180,                   /* delsym  */
  YYSYMBOL_defn = 181,                     /* defn  */
  YYSYMBOL_182_23 = 182,                   /* $@23  */
  YYSYMBOL_183_24 = 183,                   /* $@24  */
  YYSYMBOL_184_25 = 184,                   /* $@25  */
  YYSYMBOL_185_26 = 185,                   /* $@26  */
  YYSYMBOL_procname = 186,                 /* procname  */
  YYSYMBOL_procstmt = 187,                 /* procstmt  */
  YYSYMBOL_188_27 = 188,                   /* $@27  */
  YYSYMBOL_arglist = 189,                  /* arglist  */
  YYSYMBOL_arglist1 = 190,                 /* arglist1  */
  YYSYMBOL_arglist2 = 191,                 /* arglist2  */
  YYSYMBOL_eqn_list = 192,                 /* eqn_list  */
  YYSYMBOL_193_28 = 193,                   /* $@28  */
  YYSYMBOL_dep_list = 194,                 /* dep_list  */
  YYSYMBOL_equation = 195,                 /* equation  */
  YYSYMBOL_196_29 = 196,                   /* $@29  */
  YYSYMBOL_lhs = 197,                      /* lhs  */
  YYSYMBOL_198_30 = 198,                   /* $@30  */
  YYSYMBOL_rhs = 199,                      /* rhs  */
  YYSYMBOL_200_31 = 200,                   /* $@31  */
  YYSYMBOL_local = 201,                    /* local  */
  YYSYMBOL_local1 = 202,                   /* local1  */
  YYSYMBOL_localobj = 203,                 /* localobj  */
  YYSYMBOL_local2 = 204,                   /* local2  */
  YYSYMBOL_ckvar = 205,                    /* ckvar  */
  YYSYMBOL_anyname = 206                   /* anyname  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2859

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  108
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  99
/* YYNRULES -- Number of rules.  */
#define YYNRULES  284
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  553

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   343


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      96,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    92,   107,     2,
      97,    98,    90,    88,   102,    89,   101,    91,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   105,   106,
       2,    79,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    99,     2,   100,    95,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   103,     2,   104,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    80,    81,    82,    83,    84,    85,
      86,    87,    93,    94
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   141,   141,   142,   143,   144,   146,   148,   150,   152,
     154,   158,   164,   164,   165,   175,   179,   181,   184,   188,
     194,   200,   204,   204,   206,   208,   210,   212,   215,   220,
     223,   224,   224,   234,   237,   238,   241,   242,   243,   244,
     245,   247,   250,   252,   254,   256,   259,   269,   271,   274,
     276,   281,   283,   288,   290,   293,   294,   296,   300,   302,
     306,   308,   310,   323,   325,   326,   328,   330,   331,   333,
     335,   337,   346,   350,   356,   358,   360,   362,   364,   366,
     371,   382,   386,   381,   393,   397,   392,   405,   409,   413,
     419,   418,   424,   427,   428,   430,   432,   434,   434,   437,
     439,   441,   451,   453,   455,   458,   462,   467,   466,   475,
     478,   474,   484,   483,   491,   490,   497,   496,   503,   502,
     510,   509,   521,   526,   526,   532,   532,   534,   539,   547,
     551,   552,   556,   557,   557,   567,   569,   571,   573,   576,
     584,   586,   588,   588,   591,   593,   595,   597,   598,   604,
     606,   610,   612,   615,   617,   620,   623,   626,   630,   633,
     636,   637,   648,   649,   654,   656,   658,   660,   662,   665,
     667,   671,   674,   675,   677,   679,   681,   683,   685,   687,
     689,   691,   693,   695,   697,   699,   701,   703,   705,   707,
     709,   711,   713,   715,   717,   720,   721,   722,   723,   725,
     728,   733,   736,   738,   741,   744,   747,   746,   753,   761,
     796,   803,   804,   808,   810,   812,   814,   817,   822,   821,
     828,   827,   834,   833,   840,   839,   846,   853,   854,   855,
     856,   858,   858,   865,   866,   868,   870,   873,   875,   877,
     878,   883,   886,   885,   891,   893,   896,   897,   899,   898,
     903,   903,   908,   908,   913,   914,   916,   923,   935,   936,
     938,   948,   959,   967,   967,   967,   967,   967,   967,   967,
     967,   968,   968,   968,   968,   968,   968,   968,   969,   969,
     969,   969,   969,   969,   970
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "EQNEQ", "NUMBER",
  "STRING", "PRINT", "parseDELETE", "VAR", "BLTIN", "UNDEF", "WHILE", "IF",
  "ELSE", "FOR", "FUNCTION", "PROCEDURE", "RETURN", "FUNC", "parsePROC",
  "HOCOBJFUNC", "READ", "parseDOUBLE", "DEBUG", "EDIT", "FUN_BLTIN",
  "DEPENDENT", "EQUATION", "LOCAL", "HOCOBJFUNCTION", "BREAK", "CONTINUE",
  "AUTO", "STRDEF", "STOPSTMT", "CSTRING", "PARALLEL", "HELP", "ITERATOR",
  "ITERKEYWORD", "ITERSTMT", "STRINGFUNC", "OBJECTFUNC", "LOCALOBJ",
  "AUTOOBJ", "ARG", "NUMZERO", "ARGREF", "INTERNALSECTIONNAME", "PYSEC",
  "PYSECNAME", "PYSECOBJ", "SECTIONKEYWORD", "SECTION", "CONNECTKEYWORD",
  "ACCESSKEYWORD", "RANGEVAR", "MECHANISM", "INSERTKEYWORD", "FORALL",
  "NRNPNTVAR", "FORSEC", "IFSEC", "UNINSERTKEYWORD", "SETPOINTERKEYWORD",
  "SECTIONREF", "BEGINTEMPLATE", "ENDTEMPLATE", "NEW", "OBJECTVAR",
  "TEMPLATE", "OBJVARDECL", "PUBLICDECL", "EXTERNALDECL", "OBFUNCTION",
  "STRFUNCTION", "OBJECTARG", "STRINGARG", "ROP", "'='", "OR", "AND", "GT",
  "GE", "LT", "LE", "EQ", "NE", "'+'", "'-'", "'*'", "'/'", "'%'",
  "UNARYMINUS", "NOT", "'^'", "'\\n'", "'('", "')'", "'['", "']'", "'.'",
  "','", "'{'", "'}'", "':'", "';'", "'&'", "$accept", "list", "$@1",
  "asgn", "object", "$@2", "ob", "ob1", "$@3", "func_or_range_array_case",
  "template", "objvarlist", "objvarlst1", "obvarname", "publiclist",
  "externallist", "strnasgn", "string1", "string2", "strlist", "string",
  "stmt", "@4", "@5", "@6", "@7", "$@8", "$@9", "@10", "$@11", "@12",
  "@13", "@14", "@15", "@16", "@17", "iterator", "$@18", "section", "$@19",
  "pysec", "pysec1", "section_or_ob", "@20", "sectiondecl", "sectionname",
  "rangevar", "rangevar1", "$@21", "pointer", "for_init", "for_st",
  "for_cond", "for_inc", "cond", "while", "if", "begin", "end", "stmtlist",
  "expr", "function", "doublelist", "newarray", "numdimen", "newname",
  "varname", "$@22", "wholearray", "argrefdim", "array", "prlist",
  "delsym", "defn", "$@23", "$@24", "$@25", "$@26", "procname", "procstmt",
  "$@27", "arglist", "arglist1", "arglist2", "eqn_list", "$@28",
  "dep_list", "equation", "$@29", "lhs", "$@30", "rhs", "$@31", "local",
  "local1", "localobj", "local2", "ckvar", "anyname", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-439)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-161)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -439,  1130,  -439,  -439,  -439,  -439,  2155,    23,  -439,   -52,
    -439,  -439,     1,  -439,  -439,  2213,    22,    22,    22,   -38,
    -439,   -61,   -35,  -439,    26,    26,  -439,  -439,  -439,  -439,
    -439,  -439,  -439,    51,  -439,    22,  -439,  -439,  -439,  -439,
     -12,  -439,  -439,  -439,   -33,  -439,  -439,    54,   280,  -439,
    2431,  -439,  -439,  -439,    14,   127,   828,  2431,   917,   -22,
    -439,  2431,    74,  -439,  -439,  -439,  -439,  2325,  2325,  -439,
    1983,  -439,    17,  -439,  1906,   -62,    19,  -439,    16,    18,
    -439,    30,  1023,    39,    47,  1706,  -439,   -55,  -439,  -439,
      31,    31,  2747,  -439,    42,   -49,    49,  -439,  -439,  -439,
     -60,  -439,  -439,    46,    -2,  2764,    52,  -439,  -439,  -439,
    2325,  -439,  1401,    48,   108,  -439,    59,  2431,  -439,  2764,
    -439,  -439,  -439,  -439,  -439,  -439,  -439,  -439,  -439,    26,
     140,  -439,  -439,  -439,    56,    57,    62,  -439,  -439,  -439,
    2431,  -439,    26,    65,  -439,  -439,    67,    71,  2325,    91,
      80,    -7,  2431,  -439,    81,    84,    11,  -439,    87,  -439,
    -439,  -439,  -439,  -439,  -439,  -439,  -439,  -439,  -439,  -439,
    -439,  -439,  -439,  -439,  -439,  -439,  -439,  -439,  -439,  -439,
    -439,  -439,  -439,  -439,  -439,    96,    96,  -439,    90,    85,
    -439,  -439,  -439,  -439,  -439,  -439,  2325,  2431,  -439,  -439,
      86,    86,  -439,  2557,  1230,  -439,  -439,  -439,  2764,  2097,
    2431,  -439,  2431,   185,  -439,  -439,    96,  2431,  -439,     6,
    -439,  2325,  2325,  2325,  2325,  1906,  1906,  2325,  2325,  2325,
    2325,  2325,  2325,  2325,  2325,  2325,  2325,  2325,  2325,  2325,
    2325,  -439,    97,   140,  2039,  1307,  -439,  2269,  2325,  2155,
    -439,  2576,  -439,    92,     8,   188,   100,  1906,    11,   122,
    1307,   104,   105,   106,   109,   111,  -439,   114,  -439,    26,
    -439,  1307,  -439,  -439,  -439,  -439,   117,  1307,  1307,  2764,
    2325,  2325,  -439,   116,  -439,   119,   114,  -439,  -439,  -439,
    2325,  2325,  -439,  -439,  1906,  -439,  -439,  -439,  -439,   162,
    2325,    11,  -439,  2473,   120,   114,  -439,  -439,  -439,  1504,
    -439,  2431,  -439,  2764,  -439,  -439,  -439,  -439,  -439,  -439,
    -439,  -439,  2764,   673,   121,  2764,  2595,  -439,  -439,   281,
    1126,    44,    44,    44,    44,    44,    44,    32,    32,    86,
      86,    86,    86,  1307,  -439,  -439,  2764,  2431,   163,  -439,
    2764,   125,   124,  -439,  2614,  -439,  2764,  -439,  -439,  -439,
    -439,  -439,  1307,  -439,  -439,  2325,   130,  1307,   133,   143,
     144,  -439,  2325,   139,  -439,     3,   145,   166,   148,   149,
     150,  2764,  2494,   203,  2431,   139,    80,  2633,   -86,  2764,
    -439,  1906,  1906,  1906,  1906,  2652,   152,  -439,  2431,   139,
    -439,  -439,  -439,   158,  -439,   180,  2325,  1806,  1906,  -439,
    -439,   246,   165,   167,  -439,  -439,     2,  -439,  -439,  -439,
    1307,  -439,  1906,  2325,   169,  -439,  2427,  -439,   170,   157,
     157,   157,  2515,  2325,  -439,  -439,  -439,   262,  2325,  -439,
    2325,   157,  -439,  -439,  -439,  -439,   114,  -439,  2325,  -439,
    -439,  -439,  -439,  -439,   171,   163,   114,  1307,   175,  2325,
    2671,  -439,   176,  -439,  1906,  -439,  1307,  -439,  2325,  -439,
    -439,  2690,  -439,  2325,  -439,   248,  -439,  -439,  -439,  -439,
    2536,  -439,  2325,  -439,  -439,  2764,  2450,  -439,   139,  2709,
    -439,  -439,  -439,  -439,   163,  -439,   139,   179,  1307,  -439,
    2764,   200,  -439,  -439,  -439,   181,  2728,  -439,  -439,  2764,
    2431,   237,   182,  -439,  2764,   278,  2325,  -439,  -439,  -439,
     187,  2325,  -439,  -439,  -439,  1906,  1906,  -439,  2431,  -439,
     184,  2431,  -439,  2764,  -439,   642,  -439,  -439,  -439,  1230,
    2431,  -439,  -439,  1906,  2325,  -439,  -439,  1605,  -439,  -439,
    2764,  -439,  -439
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,    14,   164,    58,     0,     0,   158,     0,
     151,   157,   158,   195,   158,   158,     0,     0,     0,     0,
     158,     0,     0,   196,     0,     0,   158,   158,   158,   158,
     158,   158,    56,     0,    12,     0,   158,   158,   158,    25,
     167,   165,   211,   127,     0,   158,   125,   133,     0,   142,
       0,   158,   158,   158,     0,   158,     0,     0,     0,     0,
     158,     0,     0,   197,   198,    24,    59,     0,     0,     3,
       0,    90,   172,    30,   171,    29,     0,    66,    37,    38,
      67,     0,     0,    64,     0,     0,   128,   169,   140,   151,
       0,     0,     0,   158,    65,   166,     0,    92,   172,   171,
      29,   214,    55,     0,   169,   213,    78,   217,    69,   206,
       0,   156,     0,     0,   123,    81,     0,     0,    70,    71,
     262,   227,   228,   230,   229,   218,   226,   220,   224,     0,
       0,     8,     9,   244,   241,     0,     0,    74,    76,   205,
       0,    75,     0,     0,   222,    73,     0,     0,     0,   168,
     210,     0,     0,   158,     0,     0,     0,   100,    29,    99,
     158,   263,   264,   279,   265,   266,   267,   268,   281,   275,
     282,   283,   284,   276,   269,   270,   278,   271,   277,   272,
     273,   274,   280,   101,   112,     0,     0,   102,     0,     0,
      97,    40,    36,    39,    33,   158,     0,     0,    47,    49,
     185,   194,   178,     0,     0,     5,    68,   159,    63,     0,
       0,    11,     0,     0,    10,    54,     0,     0,     6,     0,
     103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     7,     0,     0,     0,   233,     4,     0,     0,     0,
     158,     0,   150,     0,   166,     0,     0,     0,     0,     0,
     233,     0,     0,     0,     0,     0,   199,     0,   204,     0,
     242,   233,    60,    62,    84,    13,     0,   233,   233,    16,
       0,     0,   130,     0,   129,    93,   135,   139,   211,   126,
       0,     0,   134,   143,     0,   118,   114,   120,   116,     0,
       0,     0,    23,     0,    41,    42,    46,   177,   163,     0,
     104,     0,    52,    20,    31,    48,    50,    53,    51,    61,
     208,   141,    18,     0,     0,   152,     0,   159,   159,   193,
     192,   186,   187,   188,   189,   190,   191,   179,   180,   181,
     182,   183,   184,   233,   200,    21,    15,     0,     0,   237,
     238,     0,   234,   235,     0,   216,   215,   207,   176,   149,
     107,   109,   233,   159,   124,     0,     0,   233,     0,     0,
       0,   175,     0,   201,   245,   250,     0,     0,     0,     0,
       0,    17,     0,     0,     0,   136,   209,     0,     0,    94,
     159,     0,     0,     0,     0,     0,     0,    26,     0,    43,
     161,    91,   162,     0,   158,   170,     0,     0,     0,   155,
      87,    88,     0,     0,   148,   146,     0,   239,   144,   174,
       0,   170,     0,     0,     0,    79,     0,    77,     0,     0,
       0,     0,     0,     0,   252,   248,   243,     0,     0,    28,
       0,     0,    57,    27,   212,   131,   137,   132,     0,   113,
     159,   159,   159,   159,     0,     0,    44,   233,    34,     0,
       0,   154,     0,   159,     0,   173,   233,   147,     0,   236,
     159,     0,   122,     0,    72,   254,   219,   221,   225,   202,
       0,   247,     0,   250,   246,   251,     0,   223,   138,     0,
     119,   115,   121,   117,     0,    98,    45,     0,   233,    32,
     106,     0,   153,    80,   159,     0,     0,   108,   110,    82,
       0,   258,   255,   203,   253,     0,     0,    95,    96,    19,
       0,     0,    89,   240,   145,     0,     0,   256,     0,   231,
     259,     0,   252,    85,    35,     0,   159,   159,   260,     0,
       0,   257,   249,     0,     0,   111,    83,     0,   261,   159,
     105,   232,    86
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -439,  -439,  -439,   282,  -439,  -439,    -1,     4,  -439,  -439,
    -439,  -439,  -439,  -111,  -439,  -439,  -439,    66,   443,  -439,
      72,   249,  -439,  -439,  -439,  -439,  -439,  -439,  -439,  -439,
    -439,  -439,  -439,  -439,  -439,  -439,  -439,  -439,    45,  -439,
    -439,  -439,  -439,  -439,  -439,   -96,     9,  -211,  -439,  -438,
    -439,   201,  -439,  -439,   204,  -439,  -439,  2397,  -300,  -248,
     373,  -439,  -439,    53,  -279,  -439,     0,  -439,  -159,  -439,
      13,  -439,  -439,  -439,  -439,  -439,  -439,  -439,    79,  -409,
    -439,  -258,  -439,  -128,  -439,  -439,  -439,  -439,  -439,  -189,
    -439,  -235,  -439,  -439,  -439,  -439,  -439,  -126,   368
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,   143,    98,    73,   195,    99,   100,   404,   499,
      76,    77,   304,   305,    78,    79,    80,   206,    82,    83,
     272,   402,   259,   526,   377,   543,   204,   301,   422,   423,
     525,   294,   392,   394,   391,   393,   257,   258,   103,   153,
      86,   284,   155,   156,   285,   286,   104,    88,   160,   417,
      89,   111,   324,   408,   225,    90,    91,   288,   310,   309,
     208,    93,    94,   266,   373,   267,    95,   250,   289,   149,
     150,   106,   108,    96,   262,   263,   276,   264,   125,   476,
     539,   351,   352,   353,    97,   375,   134,   436,   483,   437,
     438,   481,   482,   511,   512,   529,   530,   126,   273
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      74,   293,   366,   467,   268,    75,   434,   385,   321,     8,
      87,   448,   115,   376,   320,   219,   209,   495,   247,   379,
     380,   477,   478,   221,   133,   135,   399,   410,   411,   244,
     120,   107,   487,    29,     8,   131,   302,   121,   122,   210,
      26,   210,   222,   282,   283,   110,    85,   157,   245,    43,
      44,   123,   158,    38,    46,    39,   518,   113,    29,   129,
     124,   132,    49,   425,   189,   142,   148,    81,   151,   113,
     113,   187,   101,    74,    43,    44,   221,   196,    75,    46,
      58,    59,   199,    87,    74,   412,   244,    65,   321,    75,
     449,   357,   154,   159,    87,   248,   127,   128,   112,   468,
     188,     5,    43,    44,   424,   245,   360,    46,   435,   428,
     361,    74,   254,   205,   144,   211,    75,   268,   212,    85,
     213,    87,   237,   238,   239,    26,   214,   240,   224,   265,
      85,    32,   235,   236,   237,   238,   239,    37,    38,   240,
      39,   217,   274,   218,   243,   246,   256,   219,   120,   255,
     490,   491,   492,   493,   249,   292,   260,    85,   269,   271,
     158,   275,   270,   503,   277,    58,    59,   488,   278,   280,
     507,     8,    65,    66,   113,    43,    44,   496,   290,   281,
      46,   240,   300,    49,   295,   297,   291,   113,   210,   158,
     158,   299,    26,   316,   343,    29,   320,   362,   359,   497,
     365,   367,   368,   369,   522,    38,   370,    39,   505,   371,
     414,    43,    44,   372,   378,   317,    46,   383,    49,    49,
     158,   384,   398,   419,    74,    74,   420,   407,   427,    75,
      75,   429,    58,    59,    87,    87,   545,   546,   433,    65,
     520,   430,   431,   439,   440,   458,   441,   442,   443,   552,
      84,   296,   298,   445,   455,   457,    74,   364,   459,   464,
     475,    75,   158,   465,   466,   484,    87,   472,   474,   374,
      85,    85,   498,   494,   502,   312,   510,   519,   521,   523,
     528,   532,   318,    72,   531,   534,   540,   456,   446,   319,
     223,   547,   469,    74,   515,   226,   344,   542,    75,     0,
     396,   386,    85,    87,     0,   158,     0,     0,    74,    26,
       0,   349,     0,    75,   113,   355,     0,     0,    87,     0,
       0,     0,    38,   207,    39,     0,   349,     0,    43,    44,
       0,     0,     0,    46,   220,     0,   388,   349,     0,    85,
       0,     0,     0,   349,   349,     0,     0,   415,   418,    58,
      59,     0,   158,     0,    85,     0,    65,   416,     0,     0,
       0,   253,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,    92,     0,   240,     0,     0,   105,
       0,     0,     0,     0,     0,     0,     0,     0,   119,     0,
      74,    74,    74,    74,     0,    75,    75,    75,    75,     0,
      87,    87,    87,    87,     0,     0,    74,    74,     0,   349,
       0,    75,    75,     0,     0,     0,    87,    87,   183,     0,
       0,    74,     0,     0,   192,   193,    75,     0,   349,   198,
       0,    87,     0,   349,     0,     0,    85,    85,    85,    85,
     200,   201,     0,   203,     0,     0,     0,     0,     0,   102,
       0,     0,    85,    85,   415,   418,     0,     0,     0,   158,
       0,     0,     0,    74,   416,     0,     0,    85,    75,     0,
       0,     0,     0,    87,   327,   328,     0,     0,     0,     0,
       0,     0,     0,   251,     0,   261,   349,     0,     0,     0,
       0,     0,     0,   415,   418,     0,     0,     0,   158,     0,
       0,     0,     0,   416,     0,     0,   363,     0,     0,    85,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     287,   279,     0,   349,    74,    74,     0,     0,     0,    75,
      75,     0,   349,     0,    87,    87,     0,     0,     0,     0,
       0,     0,    74,   390,     0,     0,    74,    75,     0,     0,
       0,    75,    87,     0,     0,     0,    87,     0,     0,     0,
       0,     0,     0,     0,   349,   306,     0,     0,     0,   303,
      85,    85,     0,     0,     0,     0,     0,     0,   314,     0,
     315,     0,   313,     0,     0,     0,     0,     0,    85,     0,
       0,     0,    85,     0,   322,   323,   325,   326,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,     0,     0,   346,   350,     0,
     313,   354,   356,     0,     0,     0,     0,     0,   102,   102,
       0,     0,     0,   350,     0,     0,     0,     0,     0,     0,
     450,   451,   452,   453,   350,     0,     0,     0,     0,     0,
     350,   350,   102,   381,   382,     0,   462,   463,     0,   102,
       0,     0,     0,   387,   389,     0,     0,     0,     0,     0,
       0,   470,     0,   395,     0,     0,     0,     0,     0,   403,
       0,     0,     0,     0,     0,     0,     0,     0,   102,     0,
       0,     0,   102,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   102,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   504,   102,   413,   350,     0,     0,     0,
     102,   102,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   350,     0,   240,   426,     0,
     350,     0,     0,     0,     0,   432,     0,   544,     0,     0,
       0,     0,   287,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   306,     0,   240,     0,
       0,   405,     0,     0,   536,   537,     0,     0,   406,   460,
       0,     0,     0,     0,     0,     0,   102,     0,     0,     0,
       0,     0,   549,   350,     0,     0,   471,     0,     0,     0,
       0,     0,     0,     0,     0,   102,   480,     0,     0,     0,
     102,   485,     0,   486,     0,     0,     0,     0,     0,     0,
       0,   489,     0,     0,     0,     0,     0,     0,     0,   191,
     350,     0,   500,   161,     0,     0,   162,   163,   164,   350,
       0,   506,     0,   165,   166,     0,   509,     0,     0,     0,
       0,     0,     0,   167,     0,   514,     0,   168,     0,     0,
     169,     0,     0,   102,     0,     0,   170,     0,     0,   171,
     172,   350,   173,     0,     0,     0,     0,     0,   527,     0,
       0,   174,     0,     0,   175,   176,     0,     0,   177,   533,
       0,     0,     0,   178,   535,     0,   538,   179,   180,   541,
     102,     0,   181,   182,     0,     0,     0,     0,   548,   102,
       0,     0,     0,     0,     0,     0,     0,   550,   194,     0,
     -22,   -22,   -22,   -22,   -22,   -22,   -22,     0,   -22,   -22,
     -22,   -22,   -22,   -22,   -22,     0,     0,     0,   -22,   -22,
       0,   102,   -22,   -22,   -22,     0,   -22,   -22,   -22,   -22,
     -22,   -22,   -22,   -22,     0,     0,     0,   -22,   -22,   -22,
       0,   -22,   -22,   -22,   -22,   -22,   -22,     0,     0,   -22,
     -22,   -22,   -22,   -22,     0,   -22,   -22,     0,   -22,   -22,
     -22,   -22,     0,     0,     0,     0,   -22,   -22,   -22,     0,
       0,   -22,   -22,   -22,   -22,   -22,     0,   -22,   -22,   -22,
     -22,   -22,   -22,   -22,   -22,   -22,   -22,   -22,   -22,   -22,
       0,   -22,   -22,   -22,   -22,   -22,   -22,   -22,   -22,   -22,
     -22,   -22,   -22,   -22,   215,     0,     0,   -55,   -55,   -55,
     -55,   -55,   -55,     0,   -55,   -55,   -55,   -55,   -55,   -55,
     -55,     0,     0,     0,   -55,   -55,     0,     0,   -55,   -55,
     -55,     0,   -55,   -55,   -55,   -55,   -55,   -55,   -55,   -55,
       0,     0,     0,   -55,   -55,   -55,     0,   -55,   -55,   -55,
     -55,   -55,   -55,     0,     0,   -55,   -55,   -55,   -55,   -55,
       0,   -55,   -55,     0,   -55,   -55,   -55,   -55,     0,     0,
       0,     0,   -55,   -55,   -55,     0,     0,   -55,   -55,   -55,
     -55,   216,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   -55,     0,     0,     0,     0,   -55,     0,   -55,
     -55,   -55,     0,     0,     0,     0,   -55,   -55,     0,   -55,
       2,     3,     0,     0,     4,     5,     6,     7,     8,     9,
       0,    10,    11,     0,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,     0,    26,
      27,    28,    29,    30,    31,    32,    33,    34,     0,    35,
      36,    37,    38,     0,    39,    40,    41,    42,    43,    44,
       0,     0,    45,    46,    47,    48,    49,     0,    50,    51,
       0,    52,    53,    54,    55,     0,    56,    57,     0,    58,
      59,    60,    61,    62,    63,    64,    65,    66,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,    67,
       0,   240,     0,     0,    68,     0,    69,    70,     0,     0,
       0,   308,     0,    71,  -160,  -160,  -160,  -160,  -160,  -160,
       0,  -160,  -160,     0,  -160,  -160,  -160,  -160,     0,     0,
       0,  -160,  -160,     0,     0,  -160,  -160,  -160,     0,  -160,
    -160,  -160,  -160,  -160,  -160,  -160,  -160,     0,     0,     0,
    -160,  -160,  -160,     0,  -160,  -160,  -160,  -160,  -160,  -160,
       0,     0,  -160,  -160,  -160,  -160,  -160,     0,  -160,  -160,
       0,  -160,  -160,  -160,  -160,     0,     0,     0,     0,  -160,
    -160,  -160,     0,     0,  -160,  -160,  -160,  -160,     0,     0,
       0,     4,     5,     0,     0,     8,     9,     0,     0,  -160,
       0,     0,    13,     0,  -160,     0,  -160,  -160,    19,     0,
       0,     0,    23,  -160,  -160,     0,    26,     0,     0,    29,
       0,     0,    32,     0,     0,     0,     0,     0,    37,    38,
       0,    39,    40,    41,    42,    43,    44,     0,     0,     0,
      46,     0,     0,    49,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   347,    58,    59,     0,     0,
       0,    63,    64,    65,    66,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    67,     0,     0,     0,
       0,    68,     0,     0,    70,     4,     5,     6,     7,     8,
       9,     0,    10,    11,   348,    12,    13,    14,    15,     0,
       0,     0,    19,    20,     0,     0,    23,    24,    25,     0,
      26,    27,    28,    29,    30,    31,    32,    33,     0,     0,
       0,    36,    37,    38,     0,    39,    40,    41,    42,    43,
      44,     0,     0,    45,    46,    47,    48,    49,     0,    50,
      51,     0,    52,    53,    54,    55,     0,     0,     0,     0,
      58,    59,    60,     0,     0,    63,    64,    65,    66,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      67,     0,     0,     0,     0,    68,     0,     0,    70,     0,
       0,     0,     0,     0,    71,     0,     0,   252,     4,     5,
       6,     7,     8,     9,     0,    10,    11,     0,    12,    13,
      14,    15,     0,     0,     0,    19,    20,     0,     0,    23,
      24,    25,     0,    26,    27,    28,    29,    30,    31,    32,
      33,     0,     0,     0,    36,    37,    38,     0,    39,    40,
      41,    42,    43,    44,     0,     0,    45,    46,    47,    48,
      49,     0,    50,    51,     0,    52,    53,    54,    55,     0,
       0,     0,     0,    58,    59,    60,     0,     0,    63,    64,
      65,    66,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    67,     0,     0,     0,     0,    68,     0,
     400,    70,     0,     0,     0,     0,     0,    71,   401,     4,
       5,     6,     7,     8,     9,     0,    10,    11,     0,    12,
      13,    14,    15,     0,     0,     0,    19,    20,     0,     0,
      23,    24,    25,     0,    26,    27,    28,    29,    30,    31,
      32,    33,     0,     0,     0,    36,    37,    38,     0,    39,
      40,    41,    42,    43,    44,     0,     0,    45,    46,    47,
      48,    49,     0,    50,    51,     0,    52,    53,    54,    55,
       0,     0,     0,     0,    58,    59,    60,     0,     0,    63,
      64,    65,    66,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    67,     0,     0,     0,     0,    68,
       0,   400,    70,     0,     0,     0,     0,     0,    71,   551,
       4,     5,     6,     7,     8,     9,     0,    10,    11,     0,
      12,    13,    14,    15,     0,     0,     0,    19,    20,     0,
       0,    23,    24,    25,     0,    26,    27,    28,    29,    30,
      31,    32,    33,     0,     0,     0,    36,    37,    38,     0,
      39,    40,    41,    42,    43,    44,     0,     0,    45,    46,
      47,    48,    49,     0,    50,    51,     0,    52,    53,    54,
      55,     0,     0,     0,     0,    58,    59,    60,     0,     0,
      63,    64,    65,    66,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    67,     0,     0,     0,     0,
      68,     0,     0,    70,     0,     0,     0,   219,     0,    71,
       4,     5,     6,     7,     8,     9,     0,    10,    11,     0,
      12,    13,    14,    15,     0,     0,     0,    19,    20,     0,
       0,    23,    24,    25,     0,    26,    27,    28,    29,    30,
      31,    32,    33,     0,     0,     0,    36,    37,    38,     0,
      39,    40,    41,    42,    43,    44,     0,     0,    45,    46,
      47,    48,    49,     0,    50,    51,     0,    52,    53,    54,
      55,     0,     0,     0,     0,    58,    59,    60,     0,     0,
      63,    64,    65,    66,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    67,     0,     0,     0,     0,
      68,     0,     0,    70,   461,     0,     0,     0,     0,    71,
       4,     5,     6,     7,     8,     9,     0,    10,    11,     0,
      12,    13,    14,    15,     0,     0,     0,    19,    20,     0,
       0,    23,    24,    25,     0,    26,    27,    28,    29,    30,
      31,    32,    33,     0,     0,     0,    36,    37,    38,     0,
      39,    40,    41,    42,    43,    44,     0,     0,    45,    46,
      47,    48,    49,     0,    50,    51,     0,    52,    53,    54,
      55,     0,     0,     0,     0,    58,    59,    60,     0,     0,
      63,    64,    65,    66,   202,     0,     0,     4,     0,     0,
       0,     8,     9,     0,     0,    67,     0,     0,    13,     0,
      68,     0,     0,    70,    19,     0,     0,     0,    23,    71,
       0,     0,    26,     0,     0,    29,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    38,     0,    39,    40,    41,
      42,    43,    44,     0,     0,     0,    46,     0,     0,    49,
     345,     0,     0,     4,     0,     0,     0,     8,     9,     0,
       0,     0,    58,    59,    13,     0,     0,    63,    64,    65,
      19,     0,     0,     0,    23,     0,     0,     0,    26,     0,
       0,    29,    67,     0,     0,     0,     0,    68,     0,     0,
      70,    38,     0,    39,    40,    41,    42,    43,    44,     0,
       0,     0,    46,     0,     0,    49,     0,     0,     0,     0,
       0,     4,     5,     0,     0,     8,     9,     0,    58,    59,
       0,     0,    13,    63,    64,    65,     0,     0,    19,     0,
       0,     0,    23,     0,     0,     0,    26,     0,    67,    29,
       0,     0,    32,    68,     0,     0,    70,     0,    37,    38,
       0,    39,    40,    41,    42,    43,    44,     0,     0,     0,
      46,     0,     0,    49,     0,     0,     0,     0,     0,     4,
       5,     0,     0,     8,     9,   311,    58,    59,     0,     0,
      13,    63,    64,    65,    66,     0,    19,     0,     0,     0,
      23,     0,     0,     0,    26,     0,    67,    29,     0,     0,
      32,    68,     0,     0,    70,     0,    37,    38,     0,    39,
      40,    41,    42,    43,    44,     0,     0,     0,    46,     0,
       0,    49,     0,     0,     0,     0,     0,     4,     0,     0,
       0,     8,     9,     0,    58,    59,     0,     0,    13,    63,
      64,    65,    66,     0,    19,     0,     0,     0,    23,     0,
       0,     0,    26,     0,    67,    29,     0,     0,     0,    68,
       0,     0,    70,     0,     0,    38,     0,    39,    40,    41,
      42,    43,    44,     0,     0,     0,    46,     0,     0,    49,
       0,     0,     0,     4,     0,     0,     0,     8,     9,     0,
       0,   117,    58,    59,    13,     0,     0,    63,    64,    65,
      19,     0,     0,     0,    23,     0,     0,     0,    26,     0,
       0,    29,    67,     0,     0,     0,     0,    68,     0,     0,
      70,    38,     0,    39,    40,    41,    42,    43,    44,     0,
       0,     0,    46,     0,     0,    49,     0,     0,     0,     4,
       0,     0,     0,     8,     9,     0,     0,   311,    58,    59,
      13,     0,     0,    63,    64,    65,    19,     0,     0,     0,
      23,     0,     0,     0,    26,     0,     0,    29,    67,     0,
       0,     0,     0,    68,     0,     0,    70,    38,     0,    39,
      40,    41,    42,    43,    44,     0,     0,     0,    46,     0,
       0,    49,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    58,    59,     0,     0,     0,    63,
      64,    65,     0,     0,     0,   109,     0,     0,     0,   114,
       0,   116,   118,     0,    67,     0,     0,   130,     0,    68,
       0,     0,    70,   136,   137,   138,   139,   140,   141,     0,
       0,     0,     0,   145,   146,   147,   161,     0,     0,   162,
     163,   164,   152,     0,     0,     0,   165,   166,   184,   185,
     186,     0,   190,     0,     0,     0,   167,   197,     0,     0,
     168,     0,     0,   169,     0,     0,     0,     0,     0,   170,
       0,     0,   171,   172,     0,   173,     0,     0,     0,     0,
       0,     0,     0,     0,   174,     0,     0,   175,   176,     0,
     242,   177,     0,     0,     0,     0,   178,     0,     0,     0,
     179,   180,     0,     0,     0,   181,   182,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
       0,     0,   240,     0,     0,     0,     0,     0,     0,   473,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,     0,     0,   240,     0,     0,     0,     0,
       0,     0,   516,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,     0,     0,   240,     0,
       0,     0,     0,   397,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,     0,     0,   240,
       0,     0,     0,     0,   444,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,     0,     0,
     240,     0,     0,     0,     0,   479,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,     0,
       0,   240,     0,     0,     0,     0,   513,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
       0,     0,   240,     0,     0,   307,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,     0,
       0,   240,     0,     0,   358,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,     0,     0,
     240,     0,     0,   409,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,     0,     0,   240,
       0,     0,   421,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,     0,     0,   240,     0,
       0,   447,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,     0,     0,   240,     0,     0,
     454,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,     0,     0,   240,     0,     0,   501,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,     0,     0,   240,     0,     0,   508,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,     0,     0,   240,     0,     0,   517,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,     0,     0,   240,     0,     0,   524,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,     0,     0,   240
};

static const yytype_int16 yycheck[] =
{
       1,   160,   260,     1,   130,     1,     3,   286,   219,     8,
       1,    97,    12,   271,     8,   101,    78,   455,    78,   277,
     278,   430,   431,    78,    24,    25,   305,   327,   328,    78,
       8,     8,   441,    32,     8,    96,   195,    15,    16,   101,
      29,   101,    97,    50,    51,    97,     1,    48,    97,    48,
      49,    29,    48,    42,    53,    44,   494,    12,    32,    97,
      38,    96,    56,   363,    55,    14,    78,     1,   101,    24,
      25,    57,     6,    74,    48,    49,    78,    99,    74,    53,
      69,    70,     8,    74,    85,   343,    78,    76,   299,    85,
     390,   250,    47,    48,    85,    97,    17,    18,    97,    97,
      55,     5,    48,    49,   362,    97,    98,    53,   105,   367,
     102,   112,   112,    96,    35,    96,   112,   243,   102,    74,
     102,   112,    90,    91,    92,    29,    96,    95,    97,   129,
      85,    35,    88,    89,    90,    91,    92,    41,    42,    95,
      44,   102,   142,    96,   102,    96,    38,   101,     8,   101,
     450,   451,   452,   453,   102,   156,    97,   112,   102,    97,
     156,    96,   105,   463,    97,    69,    70,   446,    97,    78,
     470,     8,    76,    77,   129,    48,    49,   456,    97,    99,
      53,    95,    97,    56,   185,   186,   102,   142,   101,   185,
     186,   101,    29,     8,    97,    32,     8,    97,   106,   457,
      78,    97,    97,    97,   504,    42,    97,    44,   466,    98,
      47,    48,    49,    99,    97,   216,    53,   101,    56,    56,
     216,   102,   102,    98,   225,   226,   102,   106,    98,   225,
     226,    98,    69,    70,   225,   226,   536,   537,    99,    76,
     498,    98,    98,    98,    78,   404,    98,    98,    98,   549,
       1,   185,   186,    50,   102,    97,   257,   258,    78,    13,
     103,   257,   258,    98,    97,     3,   257,    98,    98,   269,
     225,   226,    97,   102,    98,   209,    28,    98,    78,    98,
      43,     3,   216,     1,   102,    98,   102,   398,   384,   217,
      89,   539,   420,   294,   483,    91,   243,   532,   294,    -1,
     301,   288,   257,   294,    -1,   301,    -1,    -1,   309,    29,
      -1,   245,    -1,   309,   269,   249,    -1,    -1,   309,    -1,
      -1,    -1,    42,    74,    44,    -1,   260,    -1,    48,    49,
      -1,    -1,    -1,    53,    85,    -1,   291,   271,    -1,   294,
      -1,    -1,    -1,   277,   278,    -1,    -1,   348,   348,    69,
      70,    -1,   348,    -1,   309,    -1,    76,   348,    -1,    -1,
      -1,   112,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,     1,    -1,    95,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    15,    -1,
     391,   392,   393,   394,    -1,   391,   392,   393,   394,    -1,
     391,   392,   393,   394,    -1,    -1,   407,   408,    -1,   343,
      -1,   407,   408,    -1,    -1,    -1,   407,   408,    50,    -1,
      -1,   422,    -1,    -1,    56,    57,   422,    -1,   362,    61,
      -1,   422,    -1,   367,    -1,    -1,   391,   392,   393,   394,
      67,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,     6,
      -1,    -1,   407,   408,   455,   455,    -1,    -1,    -1,   455,
      -1,    -1,    -1,   464,   455,    -1,    -1,   422,   464,    -1,
      -1,    -1,    -1,   464,   225,   226,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,    -1,   117,   420,    -1,    -1,    -1,
      -1,    -1,    -1,   494,   494,    -1,    -1,    -1,   494,    -1,
      -1,    -1,    -1,   494,    -1,    -1,   257,    -1,    -1,   464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     152,   148,    -1,   457,   525,   526,    -1,    -1,    -1,   525,
     526,    -1,   466,    -1,   525,   526,    -1,    -1,    -1,    -1,
      -1,    -1,   543,   294,    -1,    -1,   547,   543,    -1,    -1,
      -1,   547,   543,    -1,    -1,    -1,   547,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   498,   197,    -1,    -1,    -1,   196,
     525,   526,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,
     212,    -1,   209,    -1,    -1,    -1,    -1,    -1,   543,    -1,
      -1,    -1,   547,    -1,   221,   222,   223,   224,    -1,    -1,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,    -1,    -1,    -1,   244,   245,    -1,
     247,   248,   249,    -1,    -1,    -1,    -1,    -1,   185,   186,
      -1,    -1,    -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,
     391,   392,   393,   394,   271,    -1,    -1,    -1,    -1,    -1,
     277,   278,   209,   280,   281,    -1,   407,   408,    -1,   216,
      -1,    -1,    -1,   290,   291,    -1,    -1,    -1,    -1,    -1,
      -1,   422,    -1,   300,    -1,    -1,    -1,    -1,    -1,   311,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   245,    -1,
      -1,    -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   464,   271,   347,   343,    -1,    -1,    -1,
     277,   278,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,   362,    -1,    95,   365,    -1,
     367,    -1,    -1,    -1,    -1,   372,    -1,   105,    -1,    -1,
      -1,    -1,   384,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,   398,    -1,    95,    -1,
      -1,    98,    -1,    -1,   525,   526,    -1,    -1,   105,   406,
      -1,    -1,    -1,    -1,    -1,    -1,   343,    -1,    -1,    -1,
      -1,    -1,   543,   420,    -1,    -1,   423,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   362,   433,    -1,    -1,    -1,
     367,   438,    -1,   440,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   448,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
     457,    -1,   459,     5,    -1,    -1,     8,     9,    10,   466,
      -1,   468,    -1,    15,    16,    -1,   473,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    -1,   482,    -1,    29,    -1,    -1,
      32,    -1,    -1,   420,    -1,    -1,    38,    -1,    -1,    41,
      42,   498,    44,    -1,    -1,    -1,    -1,    -1,   510,    -1,
      -1,    53,    -1,    -1,    56,    57,    -1,    -1,    60,   516,
      -1,    -1,    -1,    65,   521,    -1,   528,    69,    70,   531,
     457,    -1,    74,    75,    -1,    -1,    -1,    -1,   540,   466,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   544,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,    11,    12,
      13,    14,    15,    16,    17,    -1,    -1,    -1,    21,    22,
      -1,   498,    25,    26,    27,    -1,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    -1,    -1,    69,    70,    71,    -1,
      -1,    74,    75,    76,    77,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,     1,    -1,    -1,     4,     5,     6,
       7,     8,     9,    -1,    11,    12,    13,    14,    15,    16,
      17,    -1,    -1,    -1,    21,    22,    -1,    -1,    25,    26,
      27,    -1,    29,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    -1,    -1,    52,    53,    54,    55,    56,
      -1,    58,    59,    -1,    61,    62,    63,    64,    -1,    -1,
      -1,    -1,    69,    70,    71,    -1,    -1,    74,    75,    76,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    -1,    -1,    -1,    -1,    94,    -1,    96,
      97,    98,    -1,    -1,    -1,    -1,   103,   104,    -1,   106,
       0,     1,    -1,    -1,     4,     5,     6,     7,     8,     9,
      -1,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    -1,    39,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      -1,    -1,    52,    53,    54,    55,    56,    -1,    58,    59,
      -1,    61,    62,    63,    64,    -1,    66,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    89,
      -1,    95,    -1,    -1,    94,    -1,    96,    97,    -1,    -1,
      -1,     1,    -1,   103,     4,     5,     6,     7,     8,     9,
      -1,    11,    12,    -1,    14,    15,    16,    17,    -1,    -1,
      -1,    21,    22,    -1,    -1,    25,    26,    27,    -1,    29,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      -1,    -1,    52,    53,    54,    55,    56,    -1,    58,    59,
      -1,    61,    62,    63,    64,    -1,    -1,    -1,    -1,    69,
      70,    71,    -1,    -1,    74,    75,    76,    77,    -1,    -1,
      -1,     4,     5,    -1,    -1,     8,     9,    -1,    -1,    89,
      -1,    -1,    15,    -1,    94,    -1,    96,    97,    21,    -1,
      -1,    -1,    25,   103,   104,    -1,    29,    -1,    -1,    32,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    -1,    -1,    -1,
      53,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    69,    70,    -1,    -1,
      -1,    74,    75,    76,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,
      -1,    94,    -1,    -1,    97,     4,     5,     6,     7,     8,
       9,    -1,    11,    12,   107,    14,    15,    16,    17,    -1,
      -1,    -1,    21,    22,    -1,    -1,    25,    26,    27,    -1,
      29,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    -1,    -1,    52,    53,    54,    55,    56,    -1,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    -1,    -1,
      69,    70,    71,    -1,    -1,    74,    75,    76,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    -1,    -1,    94,    -1,    -1,    97,    -1,
      -1,    -1,    -1,    -1,   103,    -1,    -1,   106,     4,     5,
       6,     7,     8,     9,    -1,    11,    12,    -1,    14,    15,
      16,    17,    -1,    -1,    -1,    21,    22,    -1,    -1,    25,
      26,    27,    -1,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    -1,    -1,    52,    53,    54,    55,
      56,    -1,    58,    59,    -1,    61,    62,    63,    64,    -1,
      -1,    -1,    -1,    69,    70,    71,    -1,    -1,    74,    75,
      76,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    94,    -1,
      96,    97,    -1,    -1,    -1,    -1,    -1,   103,   104,     4,
       5,     6,     7,     8,     9,    -1,    11,    12,    -1,    14,
      15,    16,    17,    -1,    -1,    -1,    21,    22,    -1,    -1,
      25,    26,    27,    -1,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    -1,    -1,    52,    53,    54,
      55,    56,    -1,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    -1,    -1,    69,    70,    71,    -1,    -1,    74,
      75,    76,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    94,
      -1,    96,    97,    -1,    -1,    -1,    -1,    -1,   103,   104,
       4,     5,     6,     7,     8,     9,    -1,    11,    12,    -1,
      14,    15,    16,    17,    -1,    -1,    -1,    21,    22,    -1,
      -1,    25,    26,    27,    -1,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    -1,    -1,    52,    53,
      54,    55,    56,    -1,    58,    59,    -1,    61,    62,    63,
      64,    -1,    -1,    -1,    -1,    69,    70,    71,    -1,    -1,
      74,    75,    76,    77,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      94,    -1,    -1,    97,    -1,    -1,    -1,   101,    -1,   103,
       4,     5,     6,     7,     8,     9,    -1,    11,    12,    -1,
      14,    15,    16,    17,    -1,    -1,    -1,    21,    22,    -1,
      -1,    25,    26,    27,    -1,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    -1,    -1,    52,    53,
      54,    55,    56,    -1,    58,    59,    -1,    61,    62,    63,
      64,    -1,    -1,    -1,    -1,    69,    70,    71,    -1,    -1,
      74,    75,    76,    77,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      94,    -1,    -1,    97,    98,    -1,    -1,    -1,    -1,   103,
       4,     5,     6,     7,     8,     9,    -1,    11,    12,    -1,
      14,    15,    16,    17,    -1,    -1,    -1,    21,    22,    -1,
      -1,    25,    26,    27,    -1,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    -1,    -1,    52,    53,
      54,    55,    56,    -1,    58,    59,    -1,    61,    62,    63,
      64,    -1,    -1,    -1,    -1,    69,    70,    71,    -1,    -1,
      74,    75,    76,    77,     1,    -1,    -1,     4,    -1,    -1,
      -1,     8,     9,    -1,    -1,    89,    -1,    -1,    15,    -1,
      94,    -1,    -1,    97,    21,    -1,    -1,    -1,    25,   103,
      -1,    -1,    29,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    53,    -1,    -1,    56,
       1,    -1,    -1,     4,    -1,    -1,    -1,     8,     9,    -1,
      -1,    -1,    69,    70,    15,    -1,    -1,    74,    75,    76,
      21,    -1,    -1,    -1,    25,    -1,    -1,    -1,    29,    -1,
      -1,    32,    89,    -1,    -1,    -1,    -1,    94,    -1,    -1,
      97,    42,    -1,    44,    45,    46,    47,    48,    49,    -1,
      -1,    -1,    53,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,     4,     5,    -1,    -1,     8,     9,    -1,    69,    70,
      -1,    -1,    15,    74,    75,    76,    -1,    -1,    21,    -1,
      -1,    -1,    25,    -1,    -1,    -1,    29,    -1,    89,    32,
      -1,    -1,    35,    94,    -1,    -1,    97,    -1,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    -1,    -1,    -1,
      53,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,     4,
       5,    -1,    -1,     8,     9,    68,    69,    70,    -1,    -1,
      15,    74,    75,    76,    77,    -1,    21,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    29,    -1,    89,    32,    -1,    -1,
      35,    94,    -1,    -1,    97,    -1,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    -1,    -1,    -1,    53,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,     4,    -1,    -1,
      -1,     8,     9,    -1,    69,    70,    -1,    -1,    15,    74,
      75,    76,    77,    -1,    21,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    29,    -1,    89,    32,    -1,    -1,    -1,    94,
      -1,    -1,    97,    -1,    -1,    42,    -1,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    53,    -1,    -1,    56,
      -1,    -1,    -1,     4,    -1,    -1,    -1,     8,     9,    -1,
      -1,    68,    69,    70,    15,    -1,    -1,    74,    75,    76,
      21,    -1,    -1,    -1,    25,    -1,    -1,    -1,    29,    -1,
      -1,    32,    89,    -1,    -1,    -1,    -1,    94,    -1,    -1,
      97,    42,    -1,    44,    45,    46,    47,    48,    49,    -1,
      -1,    -1,    53,    -1,    -1,    56,    -1,    -1,    -1,     4,
      -1,    -1,    -1,     8,     9,    -1,    -1,    68,    69,    70,
      15,    -1,    -1,    74,    75,    76,    21,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    29,    -1,    -1,    32,    89,    -1,
      -1,    -1,    -1,    94,    -1,    -1,    97,    42,    -1,    44,
      45,    46,    47,    48,    49,    -1,    -1,    -1,    53,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    69,    70,    -1,    -1,    -1,    74,
      75,    76,    -1,    -1,    -1,     8,    -1,    -1,    -1,    12,
      -1,    14,    15,    -1,    89,    -1,    -1,    20,    -1,    94,
      -1,    -1,    97,    26,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    37,    38,     5,    -1,    -1,     8,
       9,    10,    45,    -1,    -1,    -1,    15,    16,    51,    52,
      53,    -1,    55,    -1,    -1,    -1,    25,    60,    -1,    -1,
      29,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    38,
      -1,    -1,    41,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    53,    -1,    -1,    56,    57,    -1,
      93,    60,    -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,
      69,    70,    -1,    -1,    -1,    74,    75,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,   102,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    -1,    -1,    -1,    -1,
      -1,    -1,   102,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    -1,
      -1,    -1,    -1,   100,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      -1,    -1,    -1,    -1,   100,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    -1,    -1,    -1,    -1,   100,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    -1,    -1,    -1,    -1,   100,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    -1,    -1,    98,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    -1,
      -1,    95,    -1,    -1,    98,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    -1,    -1,
      95,    -1,    -1,    98,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    -1,    95,
      -1,    -1,    98,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    -1,    -1,    95,    -1,
      -1,    98,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    -1,    -1,    95,    -1,    -1,
      98,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    -1,    95,    -1,    -1,    98,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    -1,    -1,    95,    -1,    -1,    98,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    -1,    -1,    95,    -1,    -1,    98,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    -1,    -1,    95,    -1,    -1,    98,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    -1,    95,    96,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    -1,    -1,    95
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   109,     0,     1,     4,     5,     6,     7,     8,     9,
      11,    12,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    39,    40,    41,    42,    44,
      45,    46,    47,    48,    49,    52,    53,    54,    55,    56,
      58,    59,    61,    62,    63,    64,    66,    67,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    89,    94,    96,
      97,   103,   111,   112,   114,   115,   118,   119,   122,   123,
     124,   125,   126,   127,   129,   146,   148,   154,   155,   158,
     163,   164,   168,   169,   170,   174,   181,   192,   111,   114,
     115,   125,   126,   146,   154,   168,   179,     8,   180,   165,
      97,   159,    97,   146,   165,   174,   165,    68,   165,   168,
       8,    15,    16,    29,    38,   186,   205,   186,   186,    97,
     165,    96,    96,   174,   194,   174,   165,   165,   165,   165,
     165,   165,    14,   110,   186,   165,   165,   165,    78,   177,
     178,   101,   165,   147,   146,   150,   151,   114,   115,   146,
     156,     5,     8,     9,    10,    15,    16,    25,    29,    32,
      38,    41,    42,    44,    53,    56,    57,    60,    65,    69,
      70,    74,    75,   206,   165,   165,   165,    57,   146,   154,
     165,     1,   206,   206,     1,   113,    99,   165,   206,     8,
     168,   168,     1,   168,   134,    96,   125,   129,   168,    78,
     101,    96,   102,   102,    96,     1,    78,   102,    96,   101,
     129,    78,    97,   159,    97,   162,   162,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      95,    96,   165,   102,    78,    97,    96,    78,    97,   102,
     175,   168,   106,   129,   174,   101,    38,   144,   145,   130,
      97,   206,   182,   183,   185,   174,   171,   173,   205,   102,
     105,    97,   128,   206,   174,    96,   184,    97,    97,   168,
      78,    99,    50,    51,   149,   152,   153,   206,   165,   176,
      97,   102,   114,   176,   139,   114,   125,   114,   125,   101,
      97,   135,   176,   168,   120,   121,   206,    98,     1,   167,
     166,    68,   125,   168,   206,   206,     8,   114,   125,   128,
       8,   155,   168,   168,   160,   168,   168,   129,   129,   168,
     168,   168,   168,   168,   168,   168,   168,   168,   168,   168,
     168,   168,   168,    97,   171,     1,   168,    68,   107,   125,
     168,   189,   190,   191,   168,   125,   168,   176,    98,   106,
      98,   102,    97,   129,   114,    78,   189,    97,    97,    97,
      97,    98,    99,   172,   174,   193,   189,   132,    97,   189,
     189,   168,   168,   101,   102,   172,   178,   168,   146,   168,
     129,   142,   140,   143,   141,   168,   114,   100,   102,   172,
      96,   104,   129,   206,   116,    98,   105,   106,   161,    98,
     166,   166,   189,   206,    47,   114,   154,   157,   174,    98,
     102,    98,   136,   137,   189,   166,   168,    98,   189,    98,
      98,    98,   168,    99,     3,   105,   195,   197,   198,    98,
      78,    98,    98,    98,   100,    50,   153,    98,    97,   166,
     129,   129,   129,   129,    98,   102,   121,    97,   176,    78,
     168,    98,   129,   129,    13,    98,    97,     1,    97,   191,
     129,   168,    98,   102,    98,   103,   187,   187,   187,   100,
     168,   199,   200,   196,     3,   168,   168,   187,   172,   168,
     166,   166,   166,   166,   102,   157,   172,   189,    97,   117,
     168,    98,    98,   166,   129,   189,   168,   166,    98,   168,
      28,   201,   202,   100,   168,   197,   102,    98,   157,    98,
     189,    78,   166,    98,    98,   138,   131,   206,    43,   203,
     204,   102,     3,   168,    98,   168,   129,   129,   206,   188,
     102,   206,   199,   133,   105,   166,   166,   167,   206,   129,
     168,   104,   166
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   108,   109,   109,   109,   109,   109,   109,   109,   109,
     109,   109,   110,   109,   109,   111,   111,   111,   111,   111,
     111,   111,   113,   112,   112,   112,   112,   112,   112,   114,
     115,   116,   115,   115,   117,   117,   118,   118,   118,   118,
     118,   119,   120,   120,   120,   120,   121,   122,   122,   123,
     123,   124,   124,   124,   124,   125,   125,   125,   126,   126,
     127,   127,   128,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   130,   131,   129,   132,   133,   129,   129,   129,   129,
     134,   129,   129,   129,   129,   129,   129,   135,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   136,   129,   137,
     138,   129,   139,   129,   140,   129,   141,   129,   142,   129,
     143,   129,   144,   145,   144,   147,   146,   146,   146,   148,
     149,   149,   150,   151,   150,   152,   152,   152,   152,   153,
     154,   154,   156,   155,   157,   157,   157,   157,   157,   158,
     158,   159,   160,   161,   161,   162,   163,   164,   165,   166,
     167,   167,   167,   167,   168,   168,   168,   168,   168,   168,
     168,   168,   168,   168,   168,   168,   168,   168,   168,   168,
     168,   168,   168,   168,   168,   168,   168,   168,   168,   168,
     168,   168,   168,   168,   168,   169,   169,   169,   169,   170,
     170,   171,   172,   172,   173,   174,   175,   174,   174,   176,
     177,   178,   178,   179,   179,   179,   179,   180,   182,   181,
     183,   181,   184,   181,   185,   181,   186,   186,   186,   186,
     186,   188,   187,   189,   189,   190,   190,   191,   191,   191,
     191,   192,   193,   192,   194,   194,   195,   195,   196,   195,
     198,   197,   200,   199,   201,   201,   202,   202,   203,   203,
     204,   204,   205,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     0,     4,     2,     3,     3,     4,     3,     7,
       3,     3,     0,     3,     1,     1,     4,     5,     5,     1,
       1,     0,     6,     2,     0,     3,     2,     1,     1,     2,
       2,     3,     1,     2,     3,     4,     1,     2,     3,     2,
       3,     3,     3,     3,     2,     1,     1,     5,     1,     1,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     6,     2,     2,     2,     2,     5,     2,     5,
       6,     0,     0,    10,     0,     0,    11,     4,     4,     7,
       0,     4,     1,     3,     4,     7,     7,     0,     6,     2,
       2,     2,     2,     2,     3,    10,     6,     0,     7,     0,
       0,    10,     0,     5,     0,     6,     0,     6,     0,     6,
       0,     6,     4,     0,     2,     0,     3,     1,     1,     3,
       1,     3,     4,     0,     2,     1,     2,     3,     4,     1,
       1,     3,     0,     3,     1,     4,     1,     2,     1,     4,
       3,     0,     1,     3,     2,     3,     2,     1,     0,     0,
       0,     2,     2,     1,     1,     1,     1,     1,     2,     1,
       4,     1,     1,     5,     4,     4,     4,     3,     2,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     1,     1,     1,     1,     3,
       3,     2,     3,     4,     1,     2,     0,     4,     3,     2,
       1,     0,     4,     1,     1,     3,     3,     1,     0,     6,
       0,     6,     0,     6,     0,     6,     1,     1,     1,     1,
       1,     0,     6,     0,     1,     1,     3,     1,     1,     2,
       5,     2,     0,     5,     1,     3,     2,     2,     0,     5,
       0,     2,     0,     2,     0,     1,     2,     3,     0,     1,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* list: %empty  */
#line 141 "../../../../src/oc/parse.ypp"
                { ntab = 0;}
#line 2207 "parse.cpp"
    break;

  case 3: /* list: list '\n'  */
#line 142 "../../../../src/oc/parse.ypp"
                    { return '\n';}
#line 2213 "parse.cpp"
    break;

  case 4: /* list: list defn '\n'  */
#line 143 "../../../../src/oc/parse.ypp"
                         { return '\n';}
#line 2219 "parse.cpp"
    break;

  case 5: /* list: list asgn '\n'  */
#line 145 "../../../../src/oc/parse.ypp"
                { hoc_ob_check(-1); code2(nopop, STOP); return 1; }
#line 2225 "parse.cpp"
    break;

  case 6: /* list: list stmt '\n'  */
#line 147 "../../../../src/oc/parse.ypp"
                { codein(STOP); return 1; }
#line 2231 "parse.cpp"
    break;

  case 7: /* list: list expr '\n'  */
#line 149 "../../../../src/oc/parse.ypp"
                { TPDYNAM; code2(print, STOP); return 1; }
#line 2237 "parse.cpp"
    break;

  case 8: /* list: list DEBUG '\n'  */
#line 151 "../../../../src/oc/parse.ypp"
                { debug(); return '\n';}
#line 2243 "parse.cpp"
    break;

  case 9: /* list: list EDIT '\n'  */
#line 153 "../../../../src/oc/parse.ypp"
                { return 'e';}
#line 2249 "parse.cpp"
    break;

  case 10: /* list: list string1 '\n'  */
#line 155 "../../../../src/oc/parse.ypp"
                {code(prstr); code2(hoc_newline, STOP); return 1; }
#line 2255 "parse.cpp"
    break;

  case 11: /* list: list template '\n'  */
#line 158 "../../../../src/oc/parse.ypp"
                             { return '\n';}
#line 2261 "parse.cpp"
    break;

  case 12: /* $@1: %empty  */
#line 164 "../../../../src/oc/parse.ypp"
                    {hoc_help();}
#line 2267 "parse.cpp"
    break;

  case 13: /* list: list HELP $@1 '\n'  */
#line 164 "../../../../src/oc/parse.ypp"
                                       { return '\n'; }
#line 2273 "parse.cpp"
    break;

  case 14: /* list: list error  */
#line 166 "../../../../src/oc/parse.ypp"
                {clean_err(); hoc_execerror("parse error", (char*)0);
#if LINT
if (0) {
if(yydebug);
goto yynewstate;
}
#endif
		}
#line 2286 "parse.cpp"
    break;

  case 15: /* asgn: varname ROP expr  */
#line 176 "../../../../src/oc/parse.ypp"
                {Symbol *s; TPD; s = spop();
		hoc_obvar_declare(s, VAR, 1);
		code3(varpush, s, assign); codei((yyvsp[-1].narg)); PN;}
#line 2294 "parse.cpp"
    break;

  case 16: /* asgn: ARG ROP expr  */
#line 180 "../../../../src/oc/parse.ypp"
                {  TPD; defnonly("$"); argcode(argassign, (yyvsp[-2].narg)); codei((yyvsp[-1].narg)); (yyval.inst)=(yyvsp[0].inst); PN;}
#line 2300 "parse.cpp"
    break;

  case 17: /* asgn: ARGREF argrefdim ROP expr  */
#line 182 "../../../../src/oc/parse.ypp"
                { TPD; defnonly("$&"); argrefcode(hoc_argrefasgn, (yyvsp[-3].narg), (yyvsp[-2].narg)); codei((yyvsp[-1].narg)); (yyval.inst)=(yyvsp[0].inst); PN;}
#line 2306 "parse.cpp"
    break;

  case 18: /* asgn: rangevar ROP expr  */
#line 185 "../../../../src/oc/parse.ypp"
                { TPD; code(range_const); codesym(spop()); codei((yyvsp[-1].narg)); PN;}
#line 2312 "parse.cpp"
    break;

  case 19: /* asgn: ob1 ROP NEW anyname '(' arglist ')'  */
#line 189 "../../../../src/oc/parse.ypp"
                { Inst* p; hoc_opasgn_invalid((yyvsp[-5].narg));
		 code(hoc_newobj); codesym(hoc_which_template((yyvsp[-3].sym))); codei((yyvsp[-1].narg));
		 p = (Inst*)spop();
		 if (p) { p->i += 2; }
		}
#line 2322 "parse.cpp"
    break;

  case 20: /* asgn: ob1 ROP expr  */
#line 195 "../../../../src/oc/parse.ypp"
                {Inst* p; TPDYNAM; code(hoc_object_asgn); codei((yyvsp[-1].narg));
		 p = (Inst*)spop();
		 if (p) { p->i += 2; }
		}
#line 2331 "parse.cpp"
    break;

  case 21: /* asgn: varname ROP error  */
#line 200 "../../../../src/oc/parse.ypp"
                            {myerr("assignment to variable, make sure right side is a number");}
#line 2337 "parse.cpp"
    break;

  case 22: /* $@2: %empty  */
#line 204 "../../../../src/oc/parse.ypp"
                  {pushi(OBJECTVAR);pushs((yyvsp[0].sym)); pushi(CHECK);}
#line 2343 "parse.cpp"
    break;

  case 23: /* object: OBJECTVAR $@2 wholearray  */
#line 205 "../../../../src/oc/parse.ypp"
                {(yyval.inst) = (yyvsp[0].inst); code(hoc_objectvar); spop(); codesym((yyvsp[-2].sym));}
#line 2349 "parse.cpp"
    break;

  case 24: /* object: OBJECTARG  */
#line 207 "../../../../src/oc/parse.ypp"
                {defnonly("$o"); (yyval.inst) = argcode(hoc_objectarg, (yyvsp[0].narg)); pushi(OBJECTVAR);}
#line 2355 "parse.cpp"
    break;

  case 25: /* object: AUTOOBJ  */
#line 209 "../../../../src/oc/parse.ypp"
                {(yyval.inst) = code(hoc_autoobject); codesym((yyvsp[0].sym)); pushi(OBJECTVAR);}
#line 2361 "parse.cpp"
    break;

  case 26: /* object: TEMPLATE '[' expr ']'  */
#line 211 "../../../../src/oc/parse.ypp"
                {TPD; (yyval.inst) = (yyvsp[-1].inst); code(hoc_constobject); codesym((yyvsp[-3].sym)); pushi(OBJECTVAR);}
#line 2367 "parse.cpp"
    break;

  case 27: /* object: OBJECTFUNC begin '(' arglist ')'  */
#line 213 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-3].inst); code(call); codesym((yyvsp[-4].sym)); codei((yyvsp[-1].narg));
		  code(hoc_known_type); codei(OBJECTVAR); pushi(OBJECTVAR);}
#line 2374 "parse.cpp"
    break;

  case 28: /* object: HOCOBJFUNCTION begin '(' arglist ')'  */
#line 216 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-3].inst); code(call); codesym((yyvsp[-4].sym)); codei((yyvsp[-1].narg));
		  code(hoc_known_type); codei(OBJECTVAR); pushi(OBJECTVAR);}
#line 2381 "parse.cpp"
    break;

  case 29: /* ob: ob1  */
#line 220 "../../../../src/oc/parse.ypp"
        { spop(); }
#line 2387 "parse.cpp"
    break;

  case 30: /* ob1: object  */
#line 223 "../../../../src/oc/parse.ypp"
               { pushs((Symbol*)0); }
#line 2393 "parse.cpp"
    break;

  case 31: /* $@3: %empty  */
#line 224 "../../../../src/oc/parse.ypp"
                          {pushs((yyvsp[0].sym));pushi(NOCHECK);}
#line 2399 "parse.cpp"
    break;

  case 32: /* ob1: ob1 '.' anyname $@3 wholearray func_or_range_array_case  */
#line 225 "../../../../src/oc/parse.ypp"
                {int isfunc; Inst* p;
		 isfunc = ipop();
		 code(hoc_object_component); codesym(spop()); codei(ipop());
		 codei((yyvsp[0].narg));
		 codei(0); codesym(0);
		 p = codei(isfunc); /* for USE_PYTHON */
		 spop();
		 pushs((Symbol*)p); /* in case assigning to a PythonObject we will want to update isfunc to 2 */
		}
#line 2413 "parse.cpp"
    break;

  case 33: /* ob1: OBJECTVAR error  */
#line 234 "../../../../src/oc/parse.ypp"
                          {myerr("object syntax is o1.o2.o3.");}
#line 2419 "parse.cpp"
    break;

  case 34: /* func_or_range_array_case: %empty  */
#line 237 "../../../../src/oc/parse.ypp"
                {(yyval.narg) = 0; pushi(0);}
#line 2425 "parse.cpp"
    break;

  case 35: /* func_or_range_array_case: '(' arglist ')'  */
#line 239 "../../../../src/oc/parse.ypp"
                {(yyval.narg) = (yyvsp[-1].narg); pushi(1);}
#line 2431 "parse.cpp"
    break;

  case 36: /* template: BEGINTEMPLATE anyname  */
#line 241 "../../../../src/oc/parse.ypp"
                                {hoc_begintemplate((yyvsp[0].sym));}
#line 2437 "parse.cpp"
    break;

  case 39: /* template: ENDTEMPLATE anyname  */
#line 244 "../../../../src/oc/parse.ypp"
                              {hoc_endtemplate((yyvsp[0].sym));}
#line 2443 "parse.cpp"
    break;

  case 40: /* template: BEGINTEMPLATE error  */
#line 245 "../../../../src/oc/parse.ypp"
                              {myerr("begintemplate Name\npublic namelist\nexternal namelist\n...\nendtemplate Name");}
#line 2449 "parse.cpp"
    break;

  case 41: /* objvarlist: OBJVARDECL begin objvarlst1  */
#line 248 "../../../../src/oc/parse.ypp"
                {(yyval.inst) = (yyvsp[-1].inst);}
#line 2455 "parse.cpp"
    break;

  case 42: /* objvarlst1: obvarname  */
#line 251 "../../../../src/oc/parse.ypp"
                {code(hoc_objvardecl); codesym((yyvsp[0].sym)); codei(0);}
#line 2461 "parse.cpp"
    break;

  case 43: /* objvarlst1: obvarname numdimen  */
#line 253 "../../../../src/oc/parse.ypp"
                {code(hoc_objvardecl); codesym((yyvsp[-1].sym)); codei((yyvsp[0].narg));}
#line 2467 "parse.cpp"
    break;

  case 44: /* objvarlst1: objvarlst1 ',' obvarname  */
#line 255 "../../../../src/oc/parse.ypp"
                {code(hoc_objvardecl); codesym((yyvsp[0].sym)); codei(0);}
#line 2473 "parse.cpp"
    break;

  case 45: /* objvarlst1: objvarlst1 ',' obvarname numdimen  */
#line 257 "../../../../src/oc/parse.ypp"
                {code(hoc_objvardecl); codesym((yyvsp[-1].sym)); codei((yyvsp[0].narg));}
#line 2479 "parse.cpp"
    break;

  case 46: /* obvarname: anyname  */
#line 260 "../../../../src/oc/parse.ypp"
                {
		  Symbol* s;
		  s = hoc_decl((yyvsp[0].sym));
		  if (s->type != UNDEF && s->type != OBJECTVAR) {
			acterror(s->name, " already declared");
		  }
		  (yyval.sym) = s;
		}
#line 2492 "parse.cpp"
    break;

  case 47: /* publiclist: PUBLICDECL anyname  */
#line 270 "../../../../src/oc/parse.ypp"
                {hoc_add_publiclist((yyvsp[0].sym));}
#line 2498 "parse.cpp"
    break;

  case 48: /* publiclist: publiclist ',' anyname  */
#line 272 "../../../../src/oc/parse.ypp"
                {hoc_add_publiclist((yyvsp[0].sym));}
#line 2504 "parse.cpp"
    break;

  case 49: /* externallist: EXTERNALDECL VAR  */
#line 275 "../../../../src/oc/parse.ypp"
                {hoc_external_var((yyvsp[0].sym));}
#line 2510 "parse.cpp"
    break;

  case 50: /* externallist: externallist ',' VAR  */
#line 277 "../../../../src/oc/parse.ypp"
                {hoc_external_var((yyvsp[0].sym));}
#line 2516 "parse.cpp"
    break;

  case 51: /* strnasgn: string2 ROP string1  */
#line 282 "../../../../src/oc/parse.ypp"
                {hoc_opasgn_invalid((yyvsp[-1].narg)); code(assstr);}
#line 2522 "parse.cpp"
    break;

  case 52: /* strnasgn: ob1 ROP string1  */
#line 284 "../../../../src/oc/parse.ypp"
                {Inst* p = (Inst*) spop(); pushi(STRING); TPDYNAM; code(hoc_object_asgn);
		 hoc_opasgn_invalid((yyvsp[-1].narg)); codei((yyvsp[-1].narg)); hoc_ob_check(-1); code(nopop);
		 if (p) { p->i += 2; }
		}
#line 2531 "parse.cpp"
    break;

  case 53: /* strnasgn: string2 ROP ob  */
#line 289 "../../../../src/oc/parse.ypp"
                {code(hoc_asgn_obj_to_str); hoc_opasgn_invalid((yyvsp[-1].narg)); }
#line 2537 "parse.cpp"
    break;

  case 54: /* strnasgn: string2 error  */
#line 290 "../../../../src/oc/parse.ypp"
                        {myerr("string assignment: both sides need to be a string");}
#line 2543 "parse.cpp"
    break;

  case 56: /* string1: CSTRING  */
#line 295 "../../../../src/oc/parse.ypp"
                {(yyval.inst) = code(hoc_push_string); codesym((yyvsp[0].sym));}
#line 2549 "parse.cpp"
    break;

  case 57: /* string1: STRINGFUNC begin '(' arglist ')'  */
#line 297 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-3].inst); code(call); codesym((yyvsp[-4].sym)); codei((yyvsp[-1].narg));}
#line 2555 "parse.cpp"
    break;

  case 58: /* string2: STRING  */
#line 301 "../../../../src/oc/parse.ypp"
                {(yyval.inst) = code(hoc_push_string); codesym((yyvsp[0].sym));}
#line 2561 "parse.cpp"
    break;

  case 59: /* string2: STRINGARG  */
#line 303 "../../../../src/oc/parse.ypp"
                {defnonly("$s"); (yyval.inst) = argcode(hoc_stringarg, (yyvsp[0].narg));}
#line 2567 "parse.cpp"
    break;

  case 60: /* strlist: STRDEF begin string  */
#line 307 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-1].inst); }
#line 2573 "parse.cpp"
    break;

  case 62: /* string: anyname  */
#line 311 "../../../../src/oc/parse.ypp"
                {
			Symbol* s = hoc_decl((yyvsp[0].sym));
			if (s->type == UNDEF) {
				hoc_obvar_declare(s, STRING, 0);
				OPSTR(s) = (char**)emalloc(sizeof(char*));
				*OPSTR(s) = 0;
			}else if (s->type != STRING) {
				acterror(s->name, " already declared");
			}
			hoc_assign_str(OPSTR(s), "");
		}
#line 2589 "parse.cpp"
    break;

  case 63: /* stmt: expr  */
#line 324 "../../../../src/oc/parse.ypp"
                { code(nopop); hoc_ob_check(-1); /*don't check*/}
#line 2595 "parse.cpp"
    break;

  case 68: /* stmt: string1  */
#line 332 "../../../../src/oc/parse.ypp"
                { code(nopop); }
#line 2601 "parse.cpp"
    break;

  case 69: /* stmt: parseDELETE delsym  */
#line 334 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[0].inst);}
#line 2607 "parse.cpp"
    break;

  case 70: /* stmt: RETURN begin  */
#line 336 "../../../../src/oc/parse.ypp"
                { defnonly("return"); (yyval.inst)=(yyvsp[0].inst); code(procret); }
#line 2613 "parse.cpp"
    break;

  case 71: /* stmt: RETURN expr  */
#line 338 "../../../../src/oc/parse.ypp"
                {  if (indef == 3) {
			TPDYNAM; (yyval.inst) = (yyvsp[0].inst);
			code(hocobjret);
		   }else{
			TPD; defnonly("return"); (yyval.inst)=(yyvsp[0].inst);
			code(funcret);
		   }
		}
#line 2626 "parse.cpp"
    break;

  case 72: /* stmt: RETURN NEW anyname '(' arglist ')'  */
#line 347 "../../../../src/oc/parse.ypp"
                {(yyval.inst) = code(hoc_newobj_ret); codesym(hoc_which_template((yyvsp[-3].sym))); codei((yyvsp[-1].narg));
		 code(hocobjret);
		}
#line 2634 "parse.cpp"
    break;

  case 73: /* stmt: ITERSTMT begin  */
#line 351 "../../../../src/oc/parse.ypp"
                { if (indef != 2) {
acterror("iterator_statement used outside an iterator declaration", 0);
		  }
			code(hoc_iterator_stmt);
		}
#line 2644 "parse.cpp"
    break;

  case 74: /* stmt: BREAK begin  */
#line 357 "../../../../src/oc/parse.ypp"
                { code(Break); (yyval.inst) = (yyvsp[0].inst); }
#line 2650 "parse.cpp"
    break;

  case 75: /* stmt: STOPSTMT begin  */
#line 359 "../../../../src/oc/parse.ypp"
                { code(Stop); (yyval.inst) = (yyvsp[0].inst); }
#line 2656 "parse.cpp"
    break;

  case 76: /* stmt: CONTINUE begin  */
#line 361 "../../../../src/oc/parse.ypp"
                { code(Continue); (yyval.inst) = (yyvsp[0].inst); }
#line 2662 "parse.cpp"
    break;

  case 77: /* stmt: PROCEDURE begin '(' arglist ')'  */
#line 363 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-3].inst); code(call); codesym((yyvsp[-4].sym)); codei((yyvsp[-1].narg)); code(nopop); }
#line 2668 "parse.cpp"
    break;

  case 78: /* stmt: PRINT prlist  */
#line 365 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[0].inst); code(hoc_newline); }
#line 2674 "parse.cpp"
    break;

  case 79: /* stmt: FOR begin iterator stmt end  */
#line 367 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-3].inst);
		  ((yyvsp[-2].inst))[0].i = relative((yyvsp[-1].inst), (yyvsp[-2].inst), 0); /* body */
		  ((yyvsp[-2].inst))[1].i = relative((yyvsp[0].inst), (yyvsp[-2].inst), 1); /* exit */
		}
#line 2683 "parse.cpp"
    break;

  case 80: /* stmt: for_init for_st for_cond for_inc stmt end  */
#line 372 "../../../../src/oc/parse.ypp"
                        {
			((yyvsp[-4].inst))[1].i =relative((yyvsp[-1].inst), (yyvsp[-4].inst), 1);	/* body */
			((yyvsp[-4].inst))[2].i =relative((yyvsp[0].inst), (yyvsp[-4].inst), 2); /* exit from the for */
			((yyvsp[-4].inst))[3].i  =relative((yyvsp[-2].inst), (yyvsp[-4].inst), 3);	/* increment */
			(yyval.inst) = (yyvsp[-5].inst);
#if LINT
if (0){YYERROR;}
#endif
			}
#line 2697 "parse.cpp"
    break;

  case 81: /* @4: %empty  */
#line 382 "../../../../src/oc/parse.ypp"
                  { Symbol *s; (yyval.inst) = Code(varpush); codesym(s = spop());
			hoc_obvar_declare(s, VAR, 1);
		  }
#line 2705 "parse.cpp"
    break;

  case 82: /* @5: %empty  */
#line 386 "../../../../src/oc/parse.ypp"
                  {TPD; TPD; hoc_opasgn_invalid((yyvsp[-3].narg)); 
		    (yyval.inst) = code(shortfor); codei(0); codei(0);}
#line 2712 "parse.cpp"
    break;

  case 83: /* stmt: FOR varname @4 ROP expr ',' expr @5 stmt end  */
#line 389 "../../../../src/oc/parse.ypp"
                  { (yyval.inst) = (yyvsp[-8].inst); ((yyvsp[-2].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-2].inst), 1); /* body */
			   ((yyvsp[-2].inst))[2].i = relative((yyvsp[0].inst), (yyvsp[-2].inst), 2); /* exit */
		  }
#line 2720 "parse.cpp"
    break;

  case 84: /* @6: %empty  */
#line 393 "../../../../src/oc/parse.ypp"
                  { Symbol *s; (yyval.inst) = Code(varpush); codesym(s = spop());
			hoc_obvar_declare(s, VAR, 1);
		  }
#line 2728 "parse.cpp"
    break;

  case 85: /* @7: %empty  */
#line 397 "../../../../src/oc/parse.ypp"
                  {TPD; TPD; hoc_opasgn_invalid((yyvsp[-3].narg)); 
		     code(hoc_parallel_begin);
		     (yyval.inst) = code(shortfor); codei(0); codei(0);}
#line 2736 "parse.cpp"
    break;

  case 86: /* stmt: PARALLEL FOR varname @6 ROP expr ',' expr @7 stmt end  */
#line 401 "../../../../src/oc/parse.ypp"
                  { (yyval.inst) = (yyvsp[-8].inst); ((yyvsp[-2].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-2].inst), 1); /* body */
			   ((yyvsp[-2].inst))[2].i = relative((yyvsp[0].inst), (yyvsp[-2].inst), 2); /* exit */
			code(hoc_parallel_end);
		  }
#line 2745 "parse.cpp"
    break;

  case 87: /* stmt: while cond stmt end  */
#line 406 "../../../../src/oc/parse.ypp"
                {
		((yyvsp[-3].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-3].inst), 1);	/* body of loop */
		((yyvsp[-3].inst))[2].i = relative((yyvsp[0].inst), (yyvsp[-3].inst), 2); }
#line 2753 "parse.cpp"
    break;

  case 88: /* stmt: if cond stmt end  */
#line 410 "../../../../src/oc/parse.ypp"
                {
		((yyvsp[-3].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-3].inst), 1);	/* thenpart */
		((yyvsp[-3].inst))[3].i = relative((yyvsp[0].inst), (yyvsp[-3].inst), 3); }
#line 2761 "parse.cpp"
    break;

  case 89: /* stmt: if cond stmt end ELSE stmt end  */
#line 414 "../../../../src/oc/parse.ypp"
                {
		((yyvsp[-6].inst))[1].i = relative((yyvsp[-4].inst), (yyvsp[-6].inst), 1);	/* thenpart */
		((yyvsp[-6].inst))[2].i = relative((yyvsp[-1].inst), (yyvsp[-6].inst), 2);	/* elsepart */
		((yyvsp[-6].inst))[3].i = relative((yyvsp[0].inst), (yyvsp[-6].inst), 3); }
#line 2770 "parse.cpp"
    break;

  case 90: /* $@8: %empty  */
#line 419 "../../../../src/oc/parse.ypp"
                { ntab++;}
#line 2776 "parse.cpp"
    break;

  case 91: /* stmt: '{' $@8 stmtlist '}'  */
#line 421 "../../../../src/oc/parse.ypp"
                {
		ntab--; (yyval.inst) = (yyvsp[-1].inst);
		}
#line 2784 "parse.cpp"
    break;

  case 93: /* stmt: SECTIONKEYWORD begin sectiondecl  */
#line 427 "../../../../src/oc/parse.ypp"
                                           { (yyval.inst) = (yyvsp[-1].inst); }
#line 2790 "parse.cpp"
    break;

  case 94: /* stmt: CONNECTKEYWORD section_or_ob ',' expr  */
#line 429 "../../../../src/oc/parse.ypp"
                { TPD; (yyval.inst) = (yyvsp[-2].inst); code(connectsection);}
#line 2796 "parse.cpp"
    break;

  case 95: /* stmt: CONNECTKEYWORD section_or_ob ',' section '(' expr ')'  */
#line 431 "../../../../src/oc/parse.ypp"
                { TPD; (yyval.inst) = (yyvsp[-5].inst); code(simpleconnectsection);}
#line 2802 "parse.cpp"
    break;

  case 96: /* stmt: SETPOINTERKEYWORD rangevar '(' expr ')' ',' pointer  */
#line 433 "../../../../src/oc/parse.ypp"
                { TPD; (yyval.inst) = (yyvsp[-5].inst); code(connectpointer); codesym(spop());}
#line 2808 "parse.cpp"
    break;

  case 97: /* $@9: %empty  */
#line 434 "../../../../src/oc/parse.ypp"
                                  {code(nrn_cppp);}
#line 2814 "parse.cpp"
    break;

  case 98: /* stmt: SETPOINTERKEYWORD begin $@9 ob ',' pointer  */
#line 435 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-4].inst); code(connect_point_process_pointer);
			 hoc_ob_check(-1);}
#line 2821 "parse.cpp"
    break;

  case 99: /* stmt: ACCESSKEYWORD section  */
#line 438 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[0].inst); code(sec_access);}
#line 2827 "parse.cpp"
    break;

  case 100: /* stmt: ACCESSKEYWORD ob  */
#line 440 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[0].inst); hoc_ob_check(SECTION); code(sec_access_object);}
#line 2833 "parse.cpp"
    break;

  case 101: /* stmt: INSERTKEYWORD anyname  */
#line 442 "../../../../src/oc/parse.ypp"
                { Symbol* s = (yyvsp[0].sym);
			(yyval.inst) = Code(mech_access);
			if (s->type != MECHANISM) {
				s = hoc_table_lookup(s->name, hoc_built_in_symlist);
				if (!s || s->type != MECHANISM) {
					acterror((yyvsp[0].sym)->name, "is not a MECHANISM");
				}
			}
			codesym(s);}
#line 2847 "parse.cpp"
    break;

  case 102: /* stmt: UNINSERTKEYWORD MECHANISM  */
#line 452 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = Code(mech_uninsert); codesym((yyvsp[0].sym));}
#line 2853 "parse.cpp"
    break;

  case 103: /* stmt: section stmt  */
#line 454 "../../../../src/oc/parse.ypp"
                { code(sec_access_pop);}
#line 2859 "parse.cpp"
    break;

  case 104: /* stmt: ob stmt end  */
#line 456 "../../../../src/oc/parse.ypp"
                { code(sec_access_pop); hoc_ob_check(-1);
			insertcode((yyvsp[-1].inst), (yyvsp[0].inst), ob_sec_access);}
#line 2866 "parse.cpp"
    break;

  case 105: /* stmt: rangevar '(' expr ':' expr ')' ROP expr ':' expr  */
#line 459 "../../../../src/oc/parse.ypp"
                { TPD; TPD; TPD; TPD; code(range_interpolate); codesym(spop());
		  codei((yyvsp[-3].narg));
		}
#line 2874 "parse.cpp"
    break;

  case 106: /* stmt: rangevar '(' expr ')' ROP expr  */
#line 463 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(range_interpolate_single); codesym(spop());
		  codei((yyvsp[-1].narg));
		}
#line 2882 "parse.cpp"
    break;

  case 107: /* @10: %empty  */
#line 467 "../../../../src/oc/parse.ypp"
                {Symbol *s; code(varpush); codesym(s = spop());
		 hoc_obvar_declare(s, VAR, 1);
		 (yyval.inst) = code(for_segment); codei(0); codei(0);}
#line 2890 "parse.cpp"
    break;

  case 108: /* stmt: FOR '(' varname ')' @10 stmt end  */
#line 471 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-4].inst); ((yyvsp[-2].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-2].inst), 1); /* body */
			((yyvsp[-2].inst))[2].i = relative((yyvsp[0].inst), (yyvsp[-2].inst), 2); /* exit */
		}
#line 2898 "parse.cpp"
    break;

  case 109: /* $@11: %empty  */
#line 475 "../../../../src/oc/parse.ypp"
                {Symbol *s; code(varpush); codesym(s = spop());
		hoc_obvar_declare(s, VAR, 1);}
#line 2905 "parse.cpp"
    break;

  case 110: /* @12: %empty  */
#line 478 "../../../../src/oc/parse.ypp"
                { TPD; (yyval.inst) = code(for_segment1); codei(0); codei(0);}
#line 2911 "parse.cpp"
    break;

  case 111: /* stmt: FOR '(' varname ',' $@11 expr ')' @12 stmt end  */
#line 480 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-7].inst); ((yyvsp[-2].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-2].inst), 1); /* body */
			((yyvsp[-2].inst))[2].i = relative((yyvsp[0].inst), (yyvsp[-2].inst), 2); /* exit */
		}
#line 2919 "parse.cpp"
    break;

  case 112: /* @13: %empty  */
#line 484 "../../../../src/oc/parse.ypp"
                {	code(hoc_push_string); codesym((Symbol*)0);
			(yyval.inst) = code(forall_section); codei(0); codei(0);}
#line 2926 "parse.cpp"
    break;

  case 113: /* stmt: FORALL begin @13 stmt end  */
#line 487 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-3].inst); ((yyvsp[-2].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-2].inst), 1); /* body */
			((yyvsp[-2].inst))[2].i = relative((yyvsp[0].inst), (yyvsp[-2].inst), 2); /* exit */
		}
#line 2934 "parse.cpp"
    break;

  case 114: /* @14: %empty  */
#line 491 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = code(forall_section); codei(0); codei(0);}
#line 2940 "parse.cpp"
    break;

  case 115: /* stmt: FORSEC begin string1 @14 stmt end  */
#line 493 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-4].inst); ((yyvsp[-2].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-2].inst), 1); /* body */
			((yyvsp[-2].inst))[2].i = relative((yyvsp[0].inst), (yyvsp[-2].inst), 2); /* exit */
		}
#line 2948 "parse.cpp"
    break;

  case 116: /* @15: %empty  */
#line 497 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = code(hoc_ifsec); codei(0); codei(0);}
#line 2954 "parse.cpp"
    break;

  case 117: /* stmt: IFSEC begin string1 @15 stmt end  */
#line 499 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-4].inst); ((yyvsp[-2].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-2].inst), 1); /* body */
			((yyvsp[-2].inst))[2].i = relative((yyvsp[0].inst), (yyvsp[-2].inst), 2); /* exit */
		}
#line 2962 "parse.cpp"
    break;

  case 118: /* @16: %empty  */
#line 503 "../../../../src/oc/parse.ypp"
                {hoc_ob_check(-1);
		(yyval.inst) = code(forall_sectionlist); codei(0); codei(0); }
#line 2969 "parse.cpp"
    break;

  case 119: /* stmt: FORSEC begin ob @16 stmt end  */
#line 506 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-4].inst); ((yyvsp[-2].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-2].inst), 1); /* body */
			((yyvsp[-2].inst))[2].i = relative((yyvsp[0].inst), (yyvsp[-2].inst), 2); /* exit */
		}
#line 2977 "parse.cpp"
    break;

  case 120: /* @17: %empty  */
#line 510 "../../../../src/oc/parse.ypp"
                { hoc_ob_check(-1);
		 (yyval.inst) = code(hoc_ifseclist); codei(0); codei(0);
		}
#line 2985 "parse.cpp"
    break;

  case 121: /* stmt: IFSEC begin ob @17 stmt end  */
#line 515 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-4].inst); ((yyvsp[-2].inst))[1].i = relative((yyvsp[-1].inst), (yyvsp[-2].inst), 1); /* body */
			((yyvsp[-2].inst))[2].i = relative((yyvsp[0].inst), (yyvsp[-2].inst), 2); /* exit */
		}
#line 2993 "parse.cpp"
    break;

  case 122: /* iterator: ITERATOR '(' arglist ')'  */
#line 522 "../../../../src/oc/parse.ypp"
                {
		  code(hoc_iterator); codesym((yyvsp[-3].sym)); codei((yyvsp[-1].narg));
		  (yyval.inst) = progp; codein(STOP); codein(STOP);
		}
#line 3002 "parse.cpp"
    break;

  case 123: /* $@18: %empty  */
#line 526 "../../../../src/oc/parse.ypp"
          {code(hoc_push_current_object);}
#line 3008 "parse.cpp"
    break;

  case 124: /* iterator: $@18 ob  */
#line 527 "../../../../src/oc/parse.ypp"
                {codei(ITERATOR);
		  (yyval.inst) = progp; codein(STOP); codein(STOP);
		}
#line 3016 "parse.cpp"
    break;

  case 125: /* $@19: %empty  */
#line 532 "../../../../src/oc/parse.ypp"
                 {pushs((yyvsp[0].sym)); pushi(CHECK);}
#line 3022 "parse.cpp"
    break;

  case 126: /* section: SECTION $@19 wholearray  */
#line 533 "../../../../src/oc/parse.ypp"
                {code(sec_access_push); codesym(spop()); (yyval.inst) = (yyvsp[0].inst);}
#line 3028 "parse.cpp"
    break;

  case 127: /* section: INTERNALSECTIONNAME  */
#line 535 "../../../../src/oc/parse.ypp"
                {
		  (yyval.inst) = code(hoc_sec_internal_push);
		  hoc_codeptr((yyvsp[0].ptr));
		}
#line 3037 "parse.cpp"
    break;

  case 128: /* section: pysec  */
#line 540 "../../../../src/oc/parse.ypp"
                {
		  nrn_parsing_pysec_ = NULL;
		  (yyval.inst) = code(hoc_sec_internal_push);
		  hoc_codeptr((yyvsp[0].ptr));
		}
#line 3047 "parse.cpp"
    break;

  case 129: /* pysec: PYSEC '.' pysec1  */
#line 548 "../../../../src/oc/parse.ypp"
                { (yyval.ptr) = (yyvsp[0].ptr); }
#line 3053 "parse.cpp"
    break;

  case 131: /* pysec1: PYSECOBJ '.' PYSECNAME  */
#line 553 "../../../../src/oc/parse.ypp"
                { (yyval.ptr) = (yyvsp[0].ptr); }
#line 3059 "parse.cpp"
    break;

  case 132: /* section_or_ob: section '(' expr ')'  */
#line 556 "../../../../src/oc/parse.ypp"
                                    {TPD;}
#line 3065 "parse.cpp"
    break;

  case 133: /* @20: %empty  */
#line 557 "../../../../src/oc/parse.ypp"
          {(yyval.inst) = progp; code(connect_obsec_syntax);}
#line 3071 "parse.cpp"
    break;

  case 134: /* section_or_ob: @20 ob  */
#line 558 "../../../../src/oc/parse.ypp"
                {
#if 0
		 acterror("Sorry. The \"connect ob.sec...\" syntax ",
			"is not implemented");
#endif
		 hoc_ob_check(SECTION); code(ob_sec_access);
		}
#line 3083 "parse.cpp"
    break;

  case 135: /* sectiondecl: sectionname  */
#line 568 "../../../../src/oc/parse.ypp"
                { code(add_section); codesym((yyvsp[0].sym)); codei(0);}
#line 3089 "parse.cpp"
    break;

  case 136: /* sectiondecl: sectionname numdimen  */
#line 570 "../../../../src/oc/parse.ypp"
                { code(add_section); codesym((yyvsp[-1].sym)); codei((yyvsp[0].narg));}
#line 3095 "parse.cpp"
    break;

  case 137: /* sectiondecl: sectiondecl ',' sectionname  */
#line 572 "../../../../src/oc/parse.ypp"
                {code(add_section); codesym((yyvsp[0].sym)); codei(0);}
#line 3101 "parse.cpp"
    break;

  case 138: /* sectiondecl: sectiondecl ',' sectionname numdimen  */
#line 574 "../../../../src/oc/parse.ypp"
                { code(add_section); codesym((yyvsp[-1].sym)); codei((yyvsp[0].narg));}
#line 3107 "parse.cpp"
    break;

  case 139: /* sectionname: anyname  */
#line 577 "../../../../src/oc/parse.ypp"
                {
			Symbol* s;
			s = hoc_decl((yyvsp[0].sym));
			if (s->type != UNDEF && s->type != SECTION)
				acterror(s->name, " already declared");
		}
#line 3118 "parse.cpp"
    break;

  case 140: /* rangevar: rangevar1  */
#line 585 "../../../../src/oc/parse.ypp"
                { code(sec_access_push); codesym((Symbol *)0);}
#line 3124 "parse.cpp"
    break;

  case 142: /* $@21: %empty  */
#line 588 "../../../../src/oc/parse.ypp"
                    {pushs((yyvsp[0].sym)); pushi(CHECK);}
#line 3130 "parse.cpp"
    break;

  case 143: /* rangevar1: RANGEVAR $@21 wholearray  */
#line 589 "../../../../src/oc/parse.ypp"
                {(yyval.inst) = (yyvsp[0].inst);}
#line 3136 "parse.cpp"
    break;

  case 144: /* pointer: varname  */
#line 592 "../../../../src/oc/parse.ypp"
                { code3(varpush, spop(), hoc_evalpointer);}
#line 3142 "parse.cpp"
    break;

  case 145: /* pointer: rangevar '(' expr ')'  */
#line 594 "../../../../src/oc/parse.ypp"
                { TPD; code(rangevarevalpointer); codesym(spop());}
#line 3148 "parse.cpp"
    break;

  case 146: /* pointer: ob  */
#line 596 "../../../../src/oc/parse.ypp"
                {hoc_ipop(); code(hoc_ob_pointer);}
#line 3154 "parse.cpp"
    break;

  case 147: /* pointer: rangevar error  */
#line 597 "../../../../src/oc/parse.ypp"
                         {myerr("rangevariable needs explicit arc position,eg. v(.5)");}
#line 3160 "parse.cpp"
    break;

  case 148: /* pointer: ARGREF  */
#line 599 "../../../../src/oc/parse.ypp"
                {(yyval.inst) = argcode(hoc_argrefarg, (yyvsp[0].narg));}
#line 3166 "parse.cpp"
    break;

  case 149: /* for_init: FOR '(' stmt ';'  */
#line 605 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-1].inst);}
#line 3172 "parse.cpp"
    break;

  case 150: /* for_init: FOR '(' ';'  */
#line 607 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = progp; }
#line 3178 "parse.cpp"
    break;

  case 151: /* for_st: %empty  */
#line 610 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = code(forcode); codei(0); codei(0); codei(0); }
#line 3184 "parse.cpp"
    break;

  case 152: /* for_cond: expr  */
#line 613 "../../../../src/oc/parse.ypp"
                { TPD; (yyval.inst) = (yyvsp[0].inst); codein(STOP);}
#line 3190 "parse.cpp"
    break;

  case 153: /* for_inc: ';' stmt ')'  */
#line 616 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-1].inst); codein(STOP);}
#line 3196 "parse.cpp"
    break;

  case 154: /* for_inc: ';' ')'  */
#line 618 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = progp; codein(STOP);}
#line 3202 "parse.cpp"
    break;

  case 155: /* cond: '(' expr ')'  */
#line 621 "../../../../src/oc/parse.ypp"
                { TPD; codein(STOP); (yyval.inst) = (yyvsp[-1].inst);}
#line 3208 "parse.cpp"
    break;

  case 156: /* while: WHILE for_st  */
#line 624 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[0].inst); }
#line 3214 "parse.cpp"
    break;

  case 157: /* if: IF  */
#line 627 "../../../../src/oc/parse.ypp"
                { (yyval.inst)=code(ifcode); codei(0); codei(0); codei(0); }
#line 3220 "parse.cpp"
    break;

  case 158: /* begin: %empty  */
#line 630 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = progp; }
#line 3226 "parse.cpp"
    break;

  case 159: /* end: %empty  */
#line 633 "../../../../src/oc/parse.ypp"
                { codein(STOP); (yyval.inst) = progp; }
#line 3232 "parse.cpp"
    break;

  case 160: /* stmtlist: %empty  */
#line 636 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = progp; prog_error = (yyval.inst); }
#line 3238 "parse.cpp"
    break;

  case 161: /* stmtlist: stmtlist '\n'  */
#line 638 "../../../../src/oc/parse.ypp"
                {
			prog_parse_recover = progp;
			prog_error = (yyval.inst);
			if (fin && nrn_fw_eq(fin, stdin) && !pipeflag)
			{	int i;
				Printf(">");
				for (i = 0; i < ntab; i++)
					Printf("	");
			}
		}
#line 3253 "parse.cpp"
    break;

  case 163: /* stmtlist: error  */
#line 650 "../../../../src/oc/parse.ypp"
                {myerr("syntax error in compound statement");}
#line 3259 "parse.cpp"
    break;

  case 164: /* expr: NUMBER  */
#line 655 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = code(constpush); codesym((yyvsp[0].sym)); PN;}
#line 3265 "parse.cpp"
    break;

  case 165: /* expr: NUMZERO  */
#line 657 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = code(pushzero); PN;}
#line 3271 "parse.cpp"
    break;

  case 166: /* expr: varname  */
#line 659 "../../../../src/oc/parse.ypp"
                { code3(varpush, spop(), eval); PN;}
#line 3277 "parse.cpp"
    break;

  case 167: /* expr: ARG  */
#line 661 "../../../../src/oc/parse.ypp"
                { defnonly("$"); (yyval.inst) = argcode(arg, (yyvsp[0].narg)); PN;}
#line 3283 "parse.cpp"
    break;

  case 168: /* expr: ARGREF argrefdim  */
#line 663 "../../../../src/oc/parse.ypp"
                { defnonly("$&"); (yyval.inst) = argrefcode(hoc_argref, (yyvsp[-1].narg), (yyvsp[0].narg)); PN;}
#line 3289 "parse.cpp"
    break;

  case 169: /* expr: rangevar  */
#line 666 "../../../../src/oc/parse.ypp"
                {code(rangepoint); codesym(spop()); PN;}
#line 3295 "parse.cpp"
    break;

  case 170: /* expr: rangevar '(' expr ')'  */
#line 668 "../../../../src/oc/parse.ypp"
                { TPD; code(rangevareval); codesym(spop()); PN;}
#line 3301 "parse.cpp"
    break;

  case 171: /* expr: ob  */
#line 672 "../../../../src/oc/parse.ypp"
                {code(hoc_object_eval);}
#line 3307 "parse.cpp"
    break;

  case 173: /* expr: function begin '(' arglist ')'  */
#line 676 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-3].inst); code(call); codesym((yyvsp[-4].sym)); codei((yyvsp[-1].narg)); PN;}
#line 3313 "parse.cpp"
    break;

  case 174: /* expr: varname '(' arglist ')'  */
#line 678 "../../../../src/oc/parse.ypp"
                { code(call); codesym(spop()); codei((yyvsp[-1].narg)); PN;}
#line 3319 "parse.cpp"
    break;

  case 175: /* expr: READ '(' varname ')'  */
#line 680 "../../../../src/oc/parse.ypp"
                { (yyval.inst)=(yyvsp[-1].inst); code(varread); codesym(spop()); PN;}
#line 3325 "parse.cpp"
    break;

  case 176: /* expr: BLTIN '(' expr ')'  */
#line 682 "../../../../src/oc/parse.ypp"
                { TPD; (yyval.inst) = (yyvsp[-1].inst); code(bltin); codesym((yyvsp[-3].sym)); PN;}
#line 3331 "parse.cpp"
    break;

  case 177: /* expr: '(' expr ')'  */
#line 684 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-1].inst); }
#line 3337 "parse.cpp"
    break;

  case 178: /* expr: '(' error  */
#line 686 "../../../../src/oc/parse.ypp"
                {myerr("syntax error in expression");}
#line 3343 "parse.cpp"
    break;

  case 179: /* expr: expr '+' expr  */
#line 688 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(add); PN; }
#line 3349 "parse.cpp"
    break;

  case 180: /* expr: expr '-' expr  */
#line 690 "../../../../src/oc/parse.ypp"
                { TPD; TPD;code(hoc_sub); PN;}
#line 3355 "parse.cpp"
    break;

  case 181: /* expr: expr '*' expr  */
#line 692 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(mul); PN;}
#line 3361 "parse.cpp"
    break;

  case 182: /* expr: expr '/' expr  */
#line 694 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(hoc_div); PN;}
#line 3367 "parse.cpp"
    break;

  case 183: /* expr: expr '%' expr  */
#line 696 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(hoc_cyclic); PN;}
#line 3373 "parse.cpp"
    break;

  case 184: /* expr: expr '^' expr  */
#line 698 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(power); PN;}
#line 3379 "parse.cpp"
    break;

  case 185: /* expr: '-' expr  */
#line 700 "../../../../src/oc/parse.ypp"
                { TPD; (yyval.inst) = (yyvsp[0].inst); code(negate); PN;}
#line 3385 "parse.cpp"
    break;

  case 186: /* expr: expr GT expr  */
#line 702 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(gt); PN;}
#line 3391 "parse.cpp"
    break;

  case 187: /* expr: expr GE expr  */
#line 704 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(ge); PN;}
#line 3397 "parse.cpp"
    break;

  case 188: /* expr: expr LT expr  */
#line 706 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(lt); PN;}
#line 3403 "parse.cpp"
    break;

  case 189: /* expr: expr LE expr  */
#line 708 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(le); PN;}
#line 3409 "parse.cpp"
    break;

  case 190: /* expr: expr EQ expr  */
#line 710 "../../../../src/oc/parse.ypp"
                { hoc_ob_check(-1); hoc_ob_check(-1); code(eq); PN;}
#line 3415 "parse.cpp"
    break;

  case 191: /* expr: expr NE expr  */
#line 712 "../../../../src/oc/parse.ypp"
                { hoc_ob_check(-1); hoc_ob_check(-1); code(ne); PN;}
#line 3421 "parse.cpp"
    break;

  case 192: /* expr: expr AND expr  */
#line 714 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(hoc_and); PN;}
#line 3427 "parse.cpp"
    break;

  case 193: /* expr: expr OR expr  */
#line 716 "../../../../src/oc/parse.ypp"
                { TPD; TPD; code(hoc_or); PN;}
#line 3433 "parse.cpp"
    break;

  case 194: /* expr: NOT expr  */
#line 718 "../../../../src/oc/parse.ypp"
                { TPD; (yyval.inst) = (yyvsp[0].inst); code(hoc_not); PN;}
#line 3439 "parse.cpp"
    break;

  case 199: /* doublelist: parseDOUBLE begin newarray  */
#line 726 "../../../../src/oc/parse.ypp"
                {Symbol *s; code(varpush); codesym(s=spop()); (yyval.inst) = (yyvsp[-1].inst);
		code(arayinstal); codei((yyvsp[0].narg)); hoc_obvar_declare(s, VAR, 0);}
#line 3446 "parse.cpp"
    break;

  case 200: /* doublelist: doublelist ',' newarray  */
#line 729 "../../../../src/oc/parse.ypp"
                {Symbol *s; code(varpush); codesym(s = spop());
		code(arayinstal); codei((yyvsp[0].narg)); hoc_obvar_declare(s, VAR, 0);}
#line 3453 "parse.cpp"
    break;

  case 201: /* newarray: newname numdimen  */
#line 734 "../../../../src/oc/parse.ypp"
                {pushs((yyvsp[-1].sym)); (yyval.narg) = (yyvsp[0].narg);}
#line 3459 "parse.cpp"
    break;

  case 202: /* numdimen: '[' expr ']'  */
#line 737 "../../../../src/oc/parse.ypp"
                {  TPD; (yyval.narg) = 1; }
#line 3465 "parse.cpp"
    break;

  case 203: /* numdimen: numdimen '[' expr ']'  */
#line 739 "../../../../src/oc/parse.ypp"
                {  TPD;(yyval.narg) = (yyval.narg) + 1; }
#line 3471 "parse.cpp"
    break;

  case 205: /* varname: AUTO begin  */
#line 745 "../../../../src/oc/parse.ypp"
                { pushs((yyvsp[-1].sym)); (yyval.inst) = (yyvsp[0].inst); }
#line 3477 "parse.cpp"
    break;

  case 206: /* $@22: %empty  */
#line 747 "../../../../src/oc/parse.ypp"
                { if ((yyvsp[-1].sym)->subtype == USERPROPERTY) {
			code(sec_access_push); codesym((Symbol *)0);
		  }
		pushs((yyvsp[-1].sym)); pushi(CHECK);
		}
#line 3487 "parse.cpp"
    break;

  case 207: /* varname: VAR begin $@22 wholearray  */
#line 752 "../../../../src/oc/parse.ypp"
                   {(yyval.inst) = (yyvsp[-2].inst);}
#line 3493 "parse.cpp"
    break;

  case 208: /* varname: section '.' VAR  */
#line 754 "../../../../src/oc/parse.ypp"
                { if ((yyvsp[0].sym)->subtype != USERPROPERTY) {
			acterror((yyvsp[0].sym)->name, "not a section variable");
		  }
		(yyval.inst) = (yyvsp[-2].inst); pushs((yyvsp[0].sym));
		}
#line 3503 "parse.cpp"
    break;

  case 209: /* wholearray: begin array  */
#line 768 "../../../../src/oc/parse.ypp"
                {
		int d1, chk;
		Symbol *sym;
		d1 = ipop();
		chk = ipop();
		sym = spop();
   if (chk) {
	if (!ISARRAY(sym)) {
		if (d1)
			acterror(sym->name, "not an array variable");
	}else{
		if ( d1 == 0 ) { /*fake index list with all 0's*/
			int i;
			for (i=0; i<sym->arayinfo->nsub; i++) {
				code(pushzero);
			}
		}			
		else if ( d1 != sym->arayinfo->nsub) {
			acterror("wrong # of subscripts",sym->name);
		}
	}
   }else {
	pushi(d1); /* must check dynamically */
   }
		pushs(sym);
		}
#line 3534 "parse.cpp"
    break;

  case 210: /* argrefdim: array  */
#line 797 "../../../../src/oc/parse.ypp"
                {
			(yyval.narg) = ipop();
		}
#line 3542 "parse.cpp"
    break;

  case 211: /* array: %empty  */
#line 803 "../../../../src/oc/parse.ypp"
                { pushi(0); }
#line 3548 "parse.cpp"
    break;

  case 212: /* array: array '[' expr ']'  */
#line 805 "../../../../src/oc/parse.ypp"
                {  TPD;pushi(ipop() + 1); }
#line 3554 "parse.cpp"
    break;

  case 213: /* prlist: expr  */
#line 809 "../../../../src/oc/parse.ypp"
                { TPDYNAM; code(prexpr);}
#line 3560 "parse.cpp"
    break;

  case 214: /* prlist: string1  */
#line 811 "../../../../src/oc/parse.ypp"
                { code(prstr); }
#line 3566 "parse.cpp"
    break;

  case 215: /* prlist: prlist ',' expr  */
#line 813 "../../../../src/oc/parse.ypp"
                { TPDYNAM; code(prexpr);}
#line 3572 "parse.cpp"
    break;

  case 216: /* prlist: prlist ',' string1  */
#line 815 "../../../../src/oc/parse.ypp"
                { code(prstr); }
#line 3578 "parse.cpp"
    break;

  case 217: /* delsym: VAR  */
#line 818 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = code(hoc_delete_symbol); codesym((yyvsp[0].sym)); }
#line 3584 "parse.cpp"
    break;

  case 218: /* $@23: %empty  */
#line 822 "../../../../src/oc/parse.ypp"
                {(yyvsp[0].sym)->type=FUNCTION; indef=1; }
#line 3590 "parse.cpp"
    break;

  case 219: /* defn: FUNC procname $@23 '(' ')' procstmt  */
#line 824 "../../../../src/oc/parse.ypp"
                { code(procret); hoc_define((yyvsp[-4].sym));
		 (yyvsp[-4].sym)->u.u_proc->nobjauto = (yyvsp[0].narg) - localcnt;
		 (yyvsp[-4].sym)->u.u_proc->nauto=(yyvsp[0].narg); indef=0; }
#line 3598 "parse.cpp"
    break;

  case 220: /* $@24: %empty  */
#line 828 "../../../../src/oc/parse.ypp"
                { (yyvsp[0].sym)->type=PROCEDURE; indef=1; }
#line 3604 "parse.cpp"
    break;

  case 221: /* defn: parsePROC procname $@24 '(' ')' procstmt  */
#line 830 "../../../../src/oc/parse.ypp"
                { code(procret); hoc_define((yyvsp[-4].sym));
		 (yyvsp[-4].sym)->u.u_proc->nobjauto = (yyvsp[0].narg) - localcnt;
		 (yyvsp[-4].sym)->u.u_proc->nauto=(yyvsp[0].narg); indef=0; }
#line 3612 "parse.cpp"
    break;

  case 222: /* $@25: %empty  */
#line 834 "../../../../src/oc/parse.ypp"
                { (yyvsp[0].sym)->type = ITERATOR; indef=2; }
#line 3618 "parse.cpp"
    break;

  case 223: /* defn: ITERKEYWORD procname $@25 '(' ')' procstmt  */
#line 836 "../../../../src/oc/parse.ypp"
                {code(procret); hoc_define((yyvsp[-4].sym));
		 (yyvsp[-4].sym)->u.u_proc->nobjauto = (yyvsp[0].narg) - localcnt;
		 (yyvsp[-4].sym)->u.u_proc->nauto = (yyvsp[0].narg); indef = 0; }
#line 3626 "parse.cpp"
    break;

  case 224: /* $@26: %empty  */
#line 840 "../../../../src/oc/parse.ypp"
                { (yyvsp[0].sym)->type=HOCOBJFUNCTION; indef=3; }
#line 3632 "parse.cpp"
    break;

  case 225: /* defn: HOCOBJFUNC procname $@26 '(' ')' procstmt  */
#line 842 "../../../../src/oc/parse.ypp"
                { code(procret); hoc_define((yyvsp[-4].sym));
		 (yyvsp[-4].sym)->u.u_proc->nobjauto = (yyvsp[0].narg) - localcnt;
		 (yyvsp[-4].sym)->u.u_proc->nauto=(yyvsp[0].narg); indef=0; }
#line 3640 "parse.cpp"
    break;

  case 226: /* procname: ckvar  */
#line 847 "../../../../src/oc/parse.ypp"
                { Symbol *s; s=yylval.sym;
		if(s->type != UNDEF) acterror(s->name, "already defined");
		/* avoid valgrind uninitialized variable error for nautoobj */
		s->u.u_proc = (Proc *)ecalloc(1, sizeof(Proc));
		s->u.u_proc->defn.in = STOP;
		s->u.u_proc->list = (Symlist *)0; }
#line 3651 "parse.cpp"
    break;

  case 231: /* $@27: %empty  */
#line 858 "../../../../src/oc/parse.ypp"
                             {ntab++;}
#line 3657 "parse.cpp"
    break;

  case 232: /* procstmt: '{' local localobj $@27 stmtlist '}'  */
#line 859 "../../../../src/oc/parse.ypp"
                {
		ntab--;
		(yyval.narg) = (yyvsp[-4].narg) + (yyvsp[-3].narg);
		}
#line 3666 "parse.cpp"
    break;

  case 233: /* arglist: %empty  */
#line 865 "../../../../src/oc/parse.ypp"
                { (yyval.narg) = 0; }
#line 3672 "parse.cpp"
    break;

  case 235: /* arglist1: arglist2  */
#line 869 "../../../../src/oc/parse.ypp"
                {(yyval.narg) = 1;}
#line 3678 "parse.cpp"
    break;

  case 236: /* arglist1: arglist1 ',' arglist2  */
#line 871 "../../../../src/oc/parse.ypp"
                {(yyval.narg) = (yyvsp[-2].narg) + 1;}
#line 3684 "parse.cpp"
    break;

  case 237: /* arglist2: string1  */
#line 874 "../../../../src/oc/parse.ypp"
                {}
#line 3690 "parse.cpp"
    break;

  case 238: /* arglist2: expr  */
#line 876 "../../../../src/oc/parse.ypp"
                { hoc_ob_check(-1);}
#line 3696 "parse.cpp"
    break;

  case 240: /* arglist2: NEW anyname '(' arglist ')'  */
#line 879 "../../../../src/oc/parse.ypp"
                {
		 code(hoc_newobj_arg); codesym(hoc_which_template((yyvsp[-3].sym))); codei((yyvsp[-1].narg));
		}
#line 3704 "parse.cpp"
    break;

  case 241: /* eqn_list: DEPENDENT dep_list  */
#line 884 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[0].inst); }
#line 3710 "parse.cpp"
    break;

  case 242: /* $@28: %empty  */
#line 886 "../../../../src/oc/parse.ypp"
                {code3(varpush, spop(), eqn_name);
		do_equation = 1; }
#line 3717 "parse.cpp"
    break;

  case 243: /* eqn_list: EQUATION varname ':' $@28 equation  */
#line 889 "../../../../src/oc/parse.ypp"
                { (yyval.inst) = (yyvsp[-3].inst); do_equation = 0; }
#line 3723 "parse.cpp"
    break;

  case 244: /* dep_list: varname  */
#line 892 "../../../../src/oc/parse.ypp"
                {Symbol *s; code3(varpush,s= spop(), dep_make); hoc_obvar_declare(s, VAR, 0);}
#line 3729 "parse.cpp"
    break;

  case 245: /* dep_list: dep_list ',' varname  */
#line 894 "../../../../src/oc/parse.ypp"
                {Symbol *s; code3(varpush, s=spop(), dep_make); hoc_obvar_declare(s, VAR, 0);}
#line 3735 "parse.cpp"
    break;

  case 248: /* $@29: %empty  */
#line 899 "../../../../src/oc/parse.ypp"
                { code(eqn_init); }
#line 3741 "parse.cpp"
    break;

  case 250: /* $@30: %empty  */
#line 903 "../../../../src/oc/parse.ypp"
                { code(eqn_lhs); }
#line 3747 "parse.cpp"
    break;

  case 251: /* lhs: $@30 expr  */
#line 905 "../../../../src/oc/parse.ypp"
                { codein(STOP); TPD; }
#line 3753 "parse.cpp"
    break;

  case 252: /* $@31: %empty  */
#line 908 "../../../../src/oc/parse.ypp"
                { code(eqn_rhs); }
#line 3759 "parse.cpp"
    break;

  case 253: /* rhs: $@31 expr  */
#line 910 "../../../../src/oc/parse.ypp"
                { codein(STOP); TPD; }
#line 3765 "parse.cpp"
    break;

  case 254: /* local: %empty  */
#line 913 "../../../../src/oc/parse.ypp"
                { (yyval.narg) = 0; localcnt = (yyval.narg);}
#line 3771 "parse.cpp"
    break;

  case 256: /* local1: LOCAL anyname  */
#line 917 "../../../../src/oc/parse.ypp"
                {
		Symbol *sp;
		(yyval.narg) = 1; localcnt = (yyval.narg);
		sp = install((yyvsp[0].sym)->name, AUTO, 0.0, &p_symlist);
		sp->u.u_auto = (yyval.narg);
		}
#line 3782 "parse.cpp"
    break;

  case 257: /* local1: local1 ',' anyname  */
#line 924 "../../../../src/oc/parse.ypp"
                {
		Symbol *sp;
		(yyval.narg) = (yyvsp[-2].narg) + 1; localcnt = (yyval.narg);
		if (hoc_table_lookup((yyvsp[0].sym)->name, p_symlist)) {
			acterror((yyvsp[0].sym)->name, "already declared local");
		}
		sp = install((yyvsp[0].sym)->name, AUTO, 0.0, &p_symlist);
		sp->u.u_auto = (yyval.narg);
		}
#line 3796 "parse.cpp"
    break;

  case 258: /* localobj: %empty  */
#line 935 "../../../../src/oc/parse.ypp"
                { (yyval.narg) = 0;}
#line 3802 "parse.cpp"
    break;

  case 260: /* local2: LOCALOBJ anyname  */
#line 939 "../../../../src/oc/parse.ypp"
                {
		Symbol *sp;
		(yyval.narg) = 1;
		if (hoc_table_lookup((yyvsp[0].sym)->name, p_symlist)) {
			acterror((yyvsp[0].sym)->name, "already declared local");
		}
		sp = install((yyvsp[0].sym)->name, AUTOOBJ, 0.0, &p_symlist);
		sp->u.u_auto = (yyval.narg) + localcnt;
		}
#line 3816 "parse.cpp"
    break;

  case 261: /* local2: local2 ',' anyname  */
#line 949 "../../../../src/oc/parse.ypp"
                {
		Symbol *sp;
		(yyval.narg) = (yyvsp[-2].narg) + 1;
		if (hoc_table_lookup((yyvsp[0].sym)->name, p_symlist)) {
			acterror((yyvsp[0].sym)->name, "already declared local");
		}
		sp = install((yyvsp[0].sym)->name, AUTOOBJ, 0.0, &p_symlist);
		sp->u.u_auto = (yyval.narg) + localcnt;
		}
#line 3830 "parse.cpp"
    break;

  case 262: /* ckvar: VAR  */
#line 960 "../../../../src/oc/parse.ypp"
        {  Symbol* s;
	   s = hoc_decl((yyvsp[0].sym));
	   if (s->subtype != NOTUSER)
		acterror("can't redeclare user variable", s->name);
	   (yyval.sym) = s;
	}
#line 3841 "parse.cpp"
    break;


#line 3845 "parse.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 972 "../../../../src/oc/parse.ypp"

	/* end of grammar */

static void yyerror(const char* s)	/* called for yacc syntax error */
{
	execerror(s, (char *)0);
}

void acterror(const char* s, const char*t)	/* recover from action error while parsing */
{
	execerror(s,t);
}

static Inst* argrefcode(Pfrv pfrv, int i, int j){
	Inst* in;
	in = argcode(pfrv, i);
	codei(j);
	return in;
}

static Inst* argcode(Pfrv pfrv, int i) {
	Inst* in;
	if (i == 0) {
		Symbol* si = hoc_lookup("i");
		if (si->type != AUTO) {
			acterror("arg index used and i is not a LOCAL variable", 0);
		}
		in = code3(varpush, si, eval);		
		Code(pfrv);
		codei(0);
	}else{
		in = Code(pfrv);
		codei(i);
	}
	return in;
}

static void hoc_opasgn_invalid(int op) {
        if (op) {
                acterror("Invalid assignment operator.", "Only '=' allowed. ");
        }
} 

